/* postler-accounts.c generated by valac 0.10.4, the Vala compiler
 * generated from postler-accounts.vala, do not modify */

/*
 Copyright (C) 2011 Christian Dywan <christian@twotoasts.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <config.h>
#include <glib/gstdio.h>
#include <sys/stat.h>


#define POSTLER_TYPE_ACCOUNT_TYPE (postler_account_type_get_type ())

#define POSTLER_TYPE_FOLDER_TYPE (postler_folder_type_get_type ())

#define POSTLER_TYPE_MAIL_FOLDER (postler_mail_folder_get_type ())
typedef struct _PostlerMailFolder PostlerMailFolder;
#define _g_free0(var) (var = (g_free (var), NULL))

#define POSTLER_TYPE_ACCOUNT_INFO (postler_account_info_get_type ())
#define POSTLER_ACCOUNT_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfo))
#define POSTLER_ACCOUNT_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfoClass))
#define POSTLER_IS_ACCOUNT_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_ACCOUNT_INFO))
#define POSTLER_IS_ACCOUNT_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_ACCOUNT_INFO))
#define POSTLER_ACCOUNT_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_ACCOUNT_INFO, PostlerAccountInfoClass))

typedef struct _PostlerAccountInfo PostlerAccountInfo;
typedef struct _PostlerAccountInfoClass PostlerAccountInfoClass;
typedef struct _PostlerAccountInfoPrivate PostlerAccountInfoPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define POSTLER_TYPE_ACCOUNTS (postler_accounts_get_type ())
#define POSTLER_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_ACCOUNTS, PostlerAccounts))
#define POSTLER_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_ACCOUNTS, PostlerAccountsClass))
#define POSTLER_IS_ACCOUNTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_ACCOUNTS))
#define POSTLER_IS_ACCOUNTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_ACCOUNTS))
#define POSTLER_ACCOUNTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_ACCOUNTS, PostlerAccountsClass))

typedef struct _PostlerAccounts PostlerAccounts;
typedef struct _PostlerAccountsClass PostlerAccountsClass;
typedef struct _PostlerAccountsPrivate PostlerAccountsPrivate;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

typedef enum  {
	POSTLER_ACCOUNT_TYPE_MAILDIR,
	POSTLER_ACCOUNT_TYPE_IMAP,
	POSTLER_ACCOUNT_TYPE_SEARCH
} PostlerAccountType;

typedef enum  {
	POSTLER_FOLDER_TYPE_INBOX,
	POSTLER_FOLDER_TYPE_SENT,
	POSTLER_FOLDER_TYPE_DRAFTS,
	POSTLER_FOLDER_TYPE_QUEUE,
	POSTLER_FOLDER_TYPE_TRASH,
	POSTLER_FOLDER_TYPE_ARCHIVE,
	POSTLER_FOLDER_TYPE_JUNK,
	POSTLER_FOLDER_TYPE_GENERIC,
	POSTLER_FOLDER_TYPE_MAX
} PostlerFolderType;

struct _PostlerMailFolder {
	char* role;
	char* stock_id;
	char* label;
	char** localized;
	gint localized_length1;
	gint n_localized;
	PostlerFolderType type;
	gint i_type;
};

struct _PostlerAccountInfo {
	GObject parent_instance;
	PostlerAccountInfoPrivate * priv;
	char* name;
	char* display_name;
	PostlerAccountType type;
	char* realname;
	char* address;
	char* receive;
	char* send;
	gint send_port;
	char* username;
	char* password;
	char* prefix;
	char* path;
	char* certificate;
	gboolean unverified;
	char* reply;
	char* organization;
	char* signature;
	char* hide;
	char** folders;
	gint folders_length1;
};

struct _PostlerAccountInfoClass {
	GObjectClass parent_class;
};

typedef void (*PostlerAccountInfoMailFolderCallback) (gint type, PostlerMailFolder* folder, void* user_data);
struct _PostlerAccounts {
	GObject parent_instance;
	PostlerAccountsPrivate * priv;
};

struct _PostlerAccountsClass {
	GObjectClass parent_class;
	void (*add_info) (PostlerAccounts* self, PostlerAccountInfo* info);
	void (*remove_info) (PostlerAccounts* self, PostlerAccountInfo* info);
};

struct _PostlerAccountsPrivate {
	char* config_path;
	char* account_file;
	char* data_path;
	char* certificate_file;
	GKeyFile* keyfile;
	GList* infos;
};


static gpointer postler_account_info_parent_class = NULL;
static gpointer postler_accounts_parent_class = NULL;

GType postler_account_type_get_type (void) G_GNUC_CONST;
GType postler_folder_type_get_type (void) G_GNUC_CONST;
char* postler_folder_type_get_stock_id (PostlerFolderType self);
GType postler_mail_folder_get_type (void) G_GNUC_CONST;
PostlerMailFolder* postler_mail_folder_dup (const PostlerMailFolder* self);
void postler_mail_folder_free (PostlerMailFolder* self);
void postler_mail_folder_copy (const PostlerMailFolder* self, PostlerMailFolder* dest);
void postler_mail_folder_destroy (PostlerMailFolder* self);
#define POSTLER_STOCK_INBOX "mail-inbox"
#define POSTLER_STOCK_SENT_MAIL "mail-sent"
#define POSTLER_STOCK_OUTBOX "mail-outbox"
#define POSTLER_STOCK_USER_TRASH "user-trash"
#define POSTLER_STOCK_ARCHIVE "gnome-mime-application-x-archive"
char* postler_folder_type_get_label (PostlerFolderType self);
static char** _vala_array_dup1 (char** self, int length);
#define POSTLER_hide_folder_default "Apple Mail To Do"
GType postler_account_info_get_type (void) G_GNUC_CONST;
enum  {
	POSTLER_ACCOUNT_INFO_DUMMY_PROPERTY
};
const char* postler_account_info_get_folder (PostlerAccountInfo* self, PostlerFolderType type);
gboolean postler_account_info_can_delete (PostlerAccountInfo* self);
void postler_account_info_set_folder (PostlerAccountInfo* self, PostlerFolderType type, const char* folder);
void postler_account_info_get_localized_folder (PostlerAccountInfo* self, const char* folder_name, PostlerMailFolder* result);
static gboolean _vala_string_array_contains (char** stack, int stack_length, char* needle);
void postler_account_info_verify_folders (PostlerAccountInfo* self, PostlerAccountInfoMailFolderCallback callback, void* callback_target);
PostlerAccountInfo* postler_account_info_new (void);
PostlerAccountInfo* postler_account_info_construct (GType object_type);
static void postler_account_info_finalize (GObject* obj);
GType postler_accounts_get_type (void) G_GNUC_CONST;
#define POSTLER_ACCOUNTS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POSTLER_TYPE_ACCOUNTS, PostlerAccountsPrivate))
enum  {
	POSTLER_ACCOUNTS_DUMMY_PROPERTY
};
static void _g_list_free_g_object_unref (GList* self);
PostlerAccounts* postler_accounts_new (void);
PostlerAccounts* postler_accounts_construct (GType object_type);
static void postler_accounts_reload (PostlerAccounts* self);
static void postler_accounts_update_display_names (PostlerAccounts* self);
static void postler_accounts_write_keyfile (PostlerAccounts* self, GError** error);
void postler_accounts_update (PostlerAccounts* self);
static gboolean postler_accounts_remove_path (PostlerAccounts* self, const char* path, GError** error);
static void postler_accounts_delete_account (PostlerAccounts* self, PostlerAccountInfo* info);
char** postler_accounts_get_folders (PostlerAccounts* self, int* result_length1);
static void _vala_array_add1 (char*** array, int* length, int* size, char* value);
GList* postler_accounts_get_infos (PostlerAccounts* self);
static char* postler_accounts_get_tool_configfile (PostlerAccounts* self, const char* send, PostlerAccountInfo* info, GError** error);
static char* postler_accounts_get_tool_configuration (PostlerAccounts* self, const char* send, PostlerAccountInfo* info, GError** error);
char* postler_accounts_get_receive_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error);
char* postler_accounts_get_fetch_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error);
char* postler_accounts_get_send_command (PostlerAccounts* self, PostlerAccountInfo* info, const char* send, GError** error);
void postler_accounts_add_info (PostlerAccounts* self, PostlerAccountInfo* info);
static void postler_accounts_real_add_info (PostlerAccounts* self, PostlerAccountInfo* info);
void postler_accounts_remove_info (PostlerAccounts* self, PostlerAccountInfo* info);
static void postler_accounts_real_remove_info (PostlerAccounts* self, PostlerAccountInfo* info);
static void postler_accounts_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);

const char* POSTLER_sent_folders[3] = {"[Gmail]~-Sent Mail", "[Gmail]~-Gesendet", "Gesendet"};
const char* POSTLER_drafts_folders[3] = {"[Gmail]~-Drafts", "[Gmail]~-Entw&APw-rfe", "Entwurf"};
const char* POSTLER_queue_folders[1] = {"Postausgang"};
const char* POSTLER_trash_folders[3] = {"[Gmail]~-Trash", "[Gmail]~-Papierkorb", "Papierkorb"};
const char* POSTLER_archive_folders[2] = {"[Gmail]~-All Mail", "[Gmail]~-Alle Nachrichten"};
const char* POSTLER_junk_folders[1] = {"[Gmail]~-Spam"};
const PostlerMailFolder POSTLER_localized_folders[8] = {{"INBOX", POSTLER_STOCK_INBOX, N_ ("Inbox"), NULL, 0, POSTLER_FOLDER_TYPE_INBOX, 0}, {"Sent", POSTLER_STOCK_SENT_MAIL, N_ ("Sent"), POSTLER_sent_folders, G_N_ELEMENTS (POSTLER_sent_folders), POSTLER_FOLDER_TYPE_SENT, 1}, {"Drafts", NULL, N_ ("Drafts"), POSTLER_drafts_folders, G_N_ELEMENTS (POSTLER_drafts_folders), POSTLER_FOLDER_TYPE_DRAFTS, 2}, {"Queue", POSTLER_STOCK_OUTBOX, N_ ("Outbox"), POSTLER_queue_folders, G_N_ELEMENTS (POSTLER_queue_folders), POSTLER_FOLDER_TYPE_QUEUE, 3}, {"Trash", POSTLER_STOCK_USER_TRASH, N_ ("Trash"), POSTLER_trash_folders, G_N_ELEMENTS (POSTLER_trash_folders), POSTLER_FOLDER_TYPE_TRASH, 4}, {"Archive", POSTLER_STOCK_ARCHIVE, N_ ("Archive"), POSTLER_archive_folders, G_N_ELEMENTS (POSTLER_archive_folders), POSTLER_FOLDER_TYPE_ARCHIVE, 5}, {NULL, NULL, N_ ("Junk"), POSTLER_junk_folders, G_N_ELEMENTS (POSTLER_junk_folders), POSTLER_FOLDER_TYPE_JUNK, 6}, {NULL, GTK_STOCK_DIRECTORY, NULL, NULL, 0, POSTLER_FOLDER_TYPE_GENERIC, 7}};
static const char* POSTLER_ACCOUNTS_root_certificate_files[4] = {"/etc/pki/tls/certs/ca-bundle.crt", "/etc/ssl/certs/ca-certificates.crt", "/etc/ssl/certs/ca-bundle.crt", "/usr/local/share/certs/ca-root-nss.crt"};


GType postler_account_type_get_type (void) {
	static volatile gsize postler_account_type_type_id__volatile = 0;
	if (g_once_init_enter (&postler_account_type_type_id__volatile)) {
		static const GEnumValue values[] = {{POSTLER_ACCOUNT_TYPE_MAILDIR, "POSTLER_ACCOUNT_TYPE_MAILDIR", "maildir"}, {POSTLER_ACCOUNT_TYPE_IMAP, "POSTLER_ACCOUNT_TYPE_IMAP", "imap"}, {POSTLER_ACCOUNT_TYPE_SEARCH, "POSTLER_ACCOUNT_TYPE_SEARCH", "search"}, {0, NULL, NULL}};
		GType postler_account_type_type_id;
		postler_account_type_type_id = g_enum_register_static ("PostlerAccountType", values);
		g_once_init_leave (&postler_account_type_type_id__volatile, postler_account_type_type_id);
	}
	return postler_account_type_type_id__volatile;
}


#line 29 "postler-accounts.vala"
char* postler_folder_type_get_stock_id (PostlerFolderType self) {
#line 231 "postler-accounts.c"
	char* result = NULL;
	result = g_strdup (POSTLER_localized_folders[self].stock_id);
#line 30 "postler-accounts.vala"
	return result;
#line 236 "postler-accounts.c"
}


#line 32 "postler-accounts.vala"
char* postler_folder_type_get_label (PostlerFolderType self) {
#line 242 "postler-accounts.c"
	char* result = NULL;
	result = g_strdup (_ (POSTLER_localized_folders[self].label));
#line 33 "postler-accounts.vala"
	return result;
#line 247 "postler-accounts.c"
}


GType postler_folder_type_get_type (void) {
	static volatile gsize postler_folder_type_type_id__volatile = 0;
	if (g_once_init_enter (&postler_folder_type_type_id__volatile)) {
		static const GEnumValue values[] = {{POSTLER_FOLDER_TYPE_INBOX, "POSTLER_FOLDER_TYPE_INBOX", "inbox"}, {POSTLER_FOLDER_TYPE_SENT, "POSTLER_FOLDER_TYPE_SENT", "sent"}, {POSTLER_FOLDER_TYPE_DRAFTS, "POSTLER_FOLDER_TYPE_DRAFTS", "drafts"}, {POSTLER_FOLDER_TYPE_QUEUE, "POSTLER_FOLDER_TYPE_QUEUE", "queue"}, {POSTLER_FOLDER_TYPE_TRASH, "POSTLER_FOLDER_TYPE_TRASH", "trash"}, {POSTLER_FOLDER_TYPE_ARCHIVE, "POSTLER_FOLDER_TYPE_ARCHIVE", "archive"}, {POSTLER_FOLDER_TYPE_JUNK, "POSTLER_FOLDER_TYPE_JUNK", "junk"}, {POSTLER_FOLDER_TYPE_GENERIC, "POSTLER_FOLDER_TYPE_GENERIC", "generic"}, {POSTLER_FOLDER_TYPE_MAX, "POSTLER_FOLDER_TYPE_MAX", "max"}, {0, NULL, NULL}};
		GType postler_folder_type_type_id;
		postler_folder_type_type_id = g_enum_register_static ("PostlerFolderType", values);
		g_once_init_leave (&postler_folder_type_type_id__volatile, postler_folder_type_type_id);
	}
	return postler_folder_type_type_id__volatile;
}


static char** _vala_array_dup1 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


void postler_mail_folder_copy (const PostlerMailFolder* self, PostlerMailFolder* dest) {
	char** _tmp0_;
	dest->role = g_strdup (self->role);
	dest->stock_id = g_strdup (self->stock_id);
	dest->label = g_strdup (self->label);
	dest->localized = (_tmp0_ = self->localized, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup1 (_tmp0_, (*self).localized_length1));
	dest->localized_length1 = self->localized_length1;
	dest->n_localized = self->n_localized;
	dest->type = self->type;
	dest->i_type = self->i_type;
}


void postler_mail_folder_destroy (PostlerMailFolder* self) {
	_g_free0 (self->role);
	_g_free0 (self->stock_id);
	_g_free0 (self->label);
	self->localized = (_vala_array_free (self->localized, (*self).localized_length1, (GDestroyNotify) g_free), NULL);
}


PostlerMailFolder* postler_mail_folder_dup (const PostlerMailFolder* self) {
	PostlerMailFolder* dup;
	dup = g_new0 (PostlerMailFolder, 1);
	postler_mail_folder_copy (self, dup);
	return dup;
}


void postler_mail_folder_free (PostlerMailFolder* self) {
	postler_mail_folder_destroy (self);
	g_free (self);
}


GType postler_mail_folder_get_type (void) {
	static volatile gsize postler_mail_folder_type_id__volatile = 0;
	if (g_once_init_enter (&postler_mail_folder_type_id__volatile)) {
		GType postler_mail_folder_type_id;
		postler_mail_folder_type_id = g_boxed_type_register_static ("PostlerMailFolder", (GBoxedCopyFunc) postler_mail_folder_dup, (GBoxedFreeFunc) postler_mail_folder_free);
		g_once_init_leave (&postler_mail_folder_type_id__volatile, postler_mail_folder_type_id);
	}
	return postler_mail_folder_type_id__volatile;
}


#line 104 "postler-accounts.vala"
const char* postler_account_info_get_folder (PostlerAccountInfo* self, PostlerFolderType type) {
#line 322 "postler-accounts.c"
	const char* result = NULL;
#line 104 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "postler-accounts.c"
	result = self->folders[type];
#line 105 "postler-accounts.vala"
	return result;
#line 330 "postler-accounts.c"
}


#line 108 "postler-accounts.vala"
gboolean postler_account_info_can_delete (PostlerAccountInfo* self) {
#line 336 "postler-accounts.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 108 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "postler-accounts.vala"
	if (self->type == POSTLER_ACCOUNT_TYPE_SEARCH) {
#line 109 "postler-accounts.vala"
		_tmp0_ = TRUE;
#line 345 "postler-accounts.c"
	} else {
#line 109 "postler-accounts.vala"
		_tmp0_ = self->folders[POSTLER_FOLDER_TYPE_TRASH] != NULL;
#line 349 "postler-accounts.c"
	}
	result = _tmp0_;
#line 109 "postler-accounts.vala"
	return result;
#line 354 "postler-accounts.c"
}


#line 112 "postler-accounts.vala"
void postler_account_info_set_folder (PostlerAccountInfo* self, PostlerFolderType type, const char* folder) {
#line 360 "postler-accounts.c"
	char* _tmp0_;
#line 112 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 112 "postler-accounts.vala"
	g_return_if_fail (folder != NULL);
#line 113 "postler-accounts.vala"
	self->folders[type] = (_tmp0_ = g_strdup (folder), _g_free0 (self->folders[type]), _tmp0_);
#line 368 "postler-accounts.c"
}


#line 1181 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 374 "postler-accounts.c"
	char* result = NULL;
	GError * _inner_error_ = NULL;
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 383 "postler-accounts.c"
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1183 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 391 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch10_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 1184 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 402 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch10_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1184 "glib-2.0.vapi"
		return result;
#line 417 "postler-accounts.c"
	}
	goto __finally10;
	__catch10_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1186 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 428 "postler-accounts.c"
			_g_error_free0 (e);
		}
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gboolean _vala_string_array_contains (char** stack, int stack_length, char* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (_vala_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


#line 1177 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 454 "postler-accounts.c"
	gboolean result = FALSE;
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1177 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 460 "postler-accounts.c"
	result = strstr (self, needle) != NULL;
#line 1178 "glib-2.0.vapi"
	return result;
#line 464 "postler-accounts.c"
}


#line 116 "postler-accounts.vala"
void postler_account_info_get_localized_folder (PostlerAccountInfo* self, const char* folder_name, PostlerMailFolder* result) {
#line 470 "postler-accounts.c"
	char* sane_name;
#line 116 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 116 "postler-accounts.vala"
	g_return_if_fail (folder_name != NULL);
#line 476 "postler-accounts.c"
	{
		gint type;
#line 117 "postler-accounts.vala"
		type = 0;
#line 481 "postler-accounts.c"
		{
			gboolean _tmp0_;
#line 117 "postler-accounts.vala"
			_tmp0_ = TRUE;
#line 117 "postler-accounts.vala"
			while (TRUE) {
#line 117 "postler-accounts.vala"
				if (!_tmp0_) {
#line 117 "postler-accounts.vala"
					type++;
#line 492 "postler-accounts.c"
				}
#line 117 "postler-accounts.vala"
				_tmp0_ = FALSE;
#line 117 "postler-accounts.vala"
				if (!(type < POSTLER_FOLDER_TYPE_MAX)) {
#line 117 "postler-accounts.vala"
					break;
#line 500 "postler-accounts.c"
				}
#line 118 "postler-accounts.vala"
				if (_vala_strcmp0 (self->folders[type], folder_name) == 0) {
#line 504 "postler-accounts.c"
					*result = POSTLER_localized_folders[type];
#line 119 "postler-accounts.vala"
					return;
#line 508 "postler-accounts.c"
				}
			}
		}
	}
#line 120 "postler-accounts.vala"
	sane_name = string_replace (folder_name, "[Google Mail]", "[Gmail]");
#line 515 "postler-accounts.c"
	{
		gint type;
#line 121 "postler-accounts.vala"
		type = 0;
#line 520 "postler-accounts.c"
		{
			gboolean _tmp1_;
#line 121 "postler-accounts.vala"
			_tmp1_ = TRUE;
#line 121 "postler-accounts.vala"
			while (TRUE) {
#line 527 "postler-accounts.c"
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
#line 121 "postler-accounts.vala"
				if (!_tmp1_) {
#line 121 "postler-accounts.vala"
					type++;
#line 534 "postler-accounts.c"
				}
#line 121 "postler-accounts.vala"
				_tmp1_ = FALSE;
#line 121 "postler-accounts.vala"
				if (!(type < POSTLER_FOLDER_TYPE_MAX)) {
#line 121 "postler-accounts.vala"
					break;
#line 542 "postler-accounts.c"
				}
#line 122 "postler-accounts.vala"
				if (self->folders[type] == NULL) {
#line 123 "postler-accounts.vala"
					_tmp3_ = POSTLER_localized_folders[type].localized != NULL;
#line 548 "postler-accounts.c"
				} else {
#line 122 "postler-accounts.vala"
					_tmp3_ = FALSE;
#line 552 "postler-accounts.c"
				}
#line 122 "postler-accounts.vala"
				if (_tmp3_) {
#line 124 "postler-accounts.vala"
					_tmp2_ = _vala_string_array_contains (POSTLER_localized_folders[type].localized, POSTLER_localized_folders[type].localized_length1, sane_name);
#line 558 "postler-accounts.c"
				} else {
#line 122 "postler-accounts.vala"
					_tmp2_ = FALSE;
#line 562 "postler-accounts.c"
				}
#line 122 "postler-accounts.vala"
				if (_tmp2_) {
#line 566 "postler-accounts.c"
					char* _tmp4_;
					const char* role;
					gboolean _tmp5_ = FALSE;
#line 125 "postler-accounts.vala"
					self->folders[type] = (_tmp4_ = g_strdup (folder_name), _g_free0 (self->folders[type]), _tmp4_);
#line 126 "postler-accounts.vala"
					role = POSTLER_localized_folders[type].role;
#line 127 "postler-accounts.vala"
					if (role != NULL) {
#line 127 "postler-accounts.vala"
						_tmp5_ = !string_contains (self->hide, role);
#line 578 "postler-accounts.c"
					} else {
#line 127 "postler-accounts.vala"
						_tmp5_ = FALSE;
#line 582 "postler-accounts.c"
					}
#line 127 "postler-accounts.vala"
					if (_tmp5_) {
#line 586 "postler-accounts.c"
						char* _tmp6_;
						char* _tmp7_;
#line 128 "postler-accounts.vala"
						self->hide = (_tmp7_ = g_strconcat (self->hide, _tmp6_ = g_strconcat (",", role, NULL), NULL), _g_free0 (self->hide), _tmp7_);
#line 591 "postler-accounts.c"
						_g_free0 (_tmp6_);
					}
					*result = POSTLER_localized_folders[type];
					_g_free0 (sane_name);
#line 129 "postler-accounts.vala"
					return;
#line 598 "postler-accounts.c"
				}
			}
		}
	}
	*result = POSTLER_localized_folders[POSTLER_FOLDER_TYPE_GENERIC];
	_g_free0 (sane_name);
#line 132 "postler-accounts.vala"
	return;
#line 607 "postler-accounts.c"
}


#line 136 "postler-accounts.vala"
void postler_account_info_verify_folders (PostlerAccountInfo* self, PostlerAccountInfoMailFolderCallback callback, void* callback_target) {
#line 136 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 615 "postler-accounts.c"
	{
		gint type;
#line 137 "postler-accounts.vala"
		type = 0;
#line 620 "postler-accounts.c"
		{
			gboolean _tmp0_;
#line 137 "postler-accounts.vala"
			_tmp0_ = TRUE;
#line 137 "postler-accounts.vala"
			while (TRUE) {
#line 627 "postler-accounts.c"
				gboolean _tmp1_ = FALSE;
#line 137 "postler-accounts.vala"
				if (!_tmp0_) {
#line 137 "postler-accounts.vala"
					type++;
#line 633 "postler-accounts.c"
				}
#line 137 "postler-accounts.vala"
				_tmp0_ = FALSE;
#line 137 "postler-accounts.vala"
				if (!(type < POSTLER_FOLDER_TYPE_MAX)) {
#line 137 "postler-accounts.vala"
					break;
#line 641 "postler-accounts.c"
				}
#line 138 "postler-accounts.vala"
				if (self->folders[type] == NULL) {
#line 138 "postler-accounts.vala"
					_tmp1_ = POSTLER_localized_folders[type].role != NULL;
#line 647 "postler-accounts.c"
				} else {
#line 138 "postler-accounts.vala"
					_tmp1_ = FALSE;
#line 651 "postler-accounts.c"
				}
#line 138 "postler-accounts.vala"
				if (_tmp1_) {
#line 139 "postler-accounts.vala"
					if (type != POSTLER_FOLDER_TYPE_GENERIC) {
#line 657 "postler-accounts.c"
						PostlerMailFolder _tmp2_;
#line 140 "postler-accounts.vala"
						callback (type, (_tmp2_ = POSTLER_localized_folders[type], &_tmp2_), callback_target);
#line 661 "postler-accounts.c"
					}
				}
			}
		}
	}
}


#line 83 "postler-accounts.vala"
PostlerAccountInfo* postler_account_info_construct (GType object_type) {
#line 672 "postler-accounts.c"
	PostlerAccountInfo * self = NULL;
#line 83 "postler-accounts.vala"
	self = (PostlerAccountInfo*) g_object_new (object_type, NULL);
#line 676 "postler-accounts.c"
	return self;
}


#line 83 "postler-accounts.vala"
PostlerAccountInfo* postler_account_info_new (void) {
#line 83 "postler-accounts.vala"
	return postler_account_info_construct (POSTLER_TYPE_ACCOUNT_INFO);
#line 685 "postler-accounts.c"
}


static void postler_account_info_class_init (PostlerAccountInfoClass * klass) {
	postler_account_info_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = postler_account_info_finalize;
}


static void postler_account_info_instance_init (PostlerAccountInfo * self) {
	char** _tmp0_ = NULL;
	self->hide = g_strdup (POSTLER_hide_folder_default);
	self->folders = (_tmp0_ = g_new0 (char*, 8 + 1), _tmp0_[0] = NULL, _tmp0_[1] = NULL, _tmp0_[2] = NULL, _tmp0_[3] = NULL, _tmp0_[4] = NULL, _tmp0_[5] = NULL, _tmp0_[6] = NULL, _tmp0_[7] = NULL, _tmp0_);
	self->folders_length1 = 8;
}


static void postler_account_info_finalize (GObject* obj) {
	PostlerAccountInfo * self;
	self = POSTLER_ACCOUNT_INFO (obj);
	_g_free0 (self->name);
	_g_free0 (self->display_name);
	_g_free0 (self->realname);
	_g_free0 (self->address);
	_g_free0 (self->receive);
	_g_free0 (self->send);
	_g_free0 (self->username);
	_g_free0 (self->password);
	_g_free0 (self->prefix);
	_g_free0 (self->path);
	_g_free0 (self->certificate);
	_g_free0 (self->reply);
	_g_free0 (self->organization);
	_g_free0 (self->signature);
	_g_free0 (self->hide);
	self->folders = (_vala_array_free (self->folders, self->folders_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (postler_account_info_parent_class)->finalize (obj);
}


GType postler_account_info_get_type (void) {
	static volatile gsize postler_account_info_type_id__volatile = 0;
	if (g_once_init_enter (&postler_account_info_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerAccountInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_account_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerAccountInfo), 0, (GInstanceInitFunc) postler_account_info_instance_init, NULL };
		GType postler_account_info_type_id;
		postler_account_info_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerAccountInfo", &g_define_type_info, 0);
		g_once_init_leave (&postler_account_info_type_id__volatile, postler_account_info_type_id);
	}
	return postler_account_info_type_id__volatile;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


#line 160 "postler-accounts.vala"
PostlerAccounts* postler_accounts_construct (GType object_type) {
#line 746 "postler-accounts.c"
	PostlerAccounts * self = NULL;
	const char* config_dir;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	const char* data_dir;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
#line 160 "postler-accounts.vala"
	self = (PostlerAccounts*) g_object_new (object_type, NULL);
#line 161 "postler-accounts.vala"
	config_dir = g_get_user_config_dir ();
#line 162 "postler-accounts.vala"
	self->priv->config_path = (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (config_dir, "/", NULL), PACKAGE_NAME, NULL), "/", NULL), _g_free0 (self->priv->config_path), _tmp2_);
#line 763 "postler-accounts.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 163 "postler-accounts.vala"
	self->priv->account_file = (_tmp3_ = g_strconcat (self->priv->config_path, "accountrc", NULL), _g_free0 (self->priv->account_file), _tmp3_);
#line 165 "postler-accounts.vala"
	data_dir = g_get_user_data_dir ();
#line 166 "postler-accounts.vala"
	self->priv->data_path = (_tmp6_ = g_strconcat (_tmp5_ = g_strconcat (_tmp4_ = g_strconcat (data_dir, "/", NULL), PACKAGE_NAME, NULL), "/mail/", NULL), _g_free0 (self->priv->data_path), _tmp6_);
#line 772 "postler-accounts.c"
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
	{
		const char** file_collection;
		int file_collection_length1;
		int file_it;
#line 168 "postler-accounts.vala"
		file_collection = POSTLER_ACCOUNTS_root_certificate_files;
#line 781 "postler-accounts.c"
		file_collection_length1 = G_N_ELEMENTS (POSTLER_ACCOUNTS_root_certificate_files);
		for (file_it = 0; file_it < G_N_ELEMENTS (POSTLER_ACCOUNTS_root_certificate_files); file_it = file_it + 1) {
			const char* file;
			file = file_collection[file_it];
			{
#line 169 "postler-accounts.vala"
				if (g_file_test (file, G_FILE_TEST_EXISTS)) {
#line 789 "postler-accounts.c"
					char* _tmp7_;
#line 170 "postler-accounts.vala"
					self->priv->certificate_file = (_tmp7_ = g_strdup (file), _g_free0 (self->priv->certificate_file), _tmp7_);
#line 793 "postler-accounts.c"
				}
			}
		}
	}
#line 172 "postler-accounts.vala"
	if (self->priv->certificate_file == NULL) {
#line 173 "postler-accounts.vala"
		g_warning ("postler-accounts.vala:173: %s", _ ("Failed to find a root certificate file."));
#line 802 "postler-accounts.c"
	}
#line 175 "postler-accounts.vala"
	postler_accounts_reload (self);
#line 806 "postler-accounts.c"
	return self;
}


#line 160 "postler-accounts.vala"
PostlerAccounts* postler_accounts_new (void) {
#line 160 "postler-accounts.vala"
	return postler_accounts_construct (POSTLER_TYPE_ACCOUNTS);
#line 815 "postler-accounts.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 178 "postler-accounts.vala"
static void postler_accounts_update_display_names (PostlerAccounts* self) {
#line 826 "postler-accounts.c"
	guint num_accounts;
#line 178 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 180 "postler-accounts.vala"
	num_accounts = (guint) 0;
#line 832 "postler-accounts.c"
	{
		GList* info_collection;
		GList* info_it;
#line 181 "postler-accounts.vala"
		info_collection = self->priv->infos;
#line 838 "postler-accounts.c"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			PostlerAccountInfo* info;
#line 181 "postler-accounts.vala"
			info = _g_object_ref0 ((PostlerAccountInfo*) info_it->data);
#line 843 "postler-accounts.c"
			{
				char* _tmp0_;
				char* domain;
				char* _tmp11_;
				char* _tmp13_;
#line 182 "postler-accounts.vala"
				if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
#line 183 "postler-accounts.vala"
					num_accounts++;
#line 853 "postler-accounts.c"
				}
#line 184 "postler-accounts.vala"
				_tmp0_ = g_strdup (info->address);
#line 184 "postler-accounts.vala"
				if (_tmp0_ == NULL) {
#line 859 "postler-accounts.c"
					char* _tmp1_;
#line 184 "postler-accounts.vala"
					_tmp0_ = (_tmp1_ = g_strdup (info->name), _g_free0 (_tmp0_), _tmp1_);
#line 863 "postler-accounts.c"
				}
#line 184 "postler-accounts.vala"
				domain = g_strdup (g_strrstr (_tmp0_, "@"));
#line 185 "postler-accounts.vala"
				if (domain != NULL) {
#line 869 "postler-accounts.c"
					const char* _tmp6_;
					char* _tmp7_;
					{
						GList* account_info_collection;
						GList* account_info_it;
#line 186 "postler-accounts.vala"
						account_info_collection = self->priv->infos;
#line 877 "postler-accounts.c"
						for (account_info_it = account_info_collection; account_info_it != NULL; account_info_it = account_info_it->next) {
							PostlerAccountInfo* account_info;
#line 186 "postler-accounts.vala"
							account_info = _g_object_ref0 ((PostlerAccountInfo*) account_info_it->data);
#line 882 "postler-accounts.c"
							{
								char* _tmp2_;
								const char* address;
								gboolean _tmp4_ = FALSE;
#line 187 "postler-accounts.vala"
								_tmp2_ = g_strdup (account_info->address);
#line 187 "postler-accounts.vala"
								if (_tmp2_ == NULL) {
#line 891 "postler-accounts.c"
									char* _tmp3_;
#line 187 "postler-accounts.vala"
									_tmp2_ = (_tmp3_ = g_strdup (account_info->name), _g_free0 (_tmp2_), _tmp3_);
#line 895 "postler-accounts.c"
								}
#line 187 "postler-accounts.vala"
								address = _tmp2_;
#line 188 "postler-accounts.vala"
								if (account_info != info) {
#line 188 "postler-accounts.vala"
									_tmp4_ = string_contains (address, domain);
#line 903 "postler-accounts.c"
								} else {
#line 188 "postler-accounts.vala"
									_tmp4_ = FALSE;
#line 907 "postler-accounts.c"
								}
#line 188 "postler-accounts.vala"
								if (_tmp4_) {
#line 911 "postler-accounts.c"
									char* _tmp5_;
#line 189 "postler-accounts.vala"
									domain = (_tmp5_ = NULL, _g_free0 (domain), _tmp5_);
#line 915 "postler-accounts.c"
									_g_free0 (_tmp2_);
									_g_object_unref0 (account_info);
#line 190 "postler-accounts.vala"
									break;
#line 920 "postler-accounts.c"
								}
								_g_free0 (_tmp2_);
								_g_object_unref0 (account_info);
							}
						}
					}
					_tmp6_ = NULL;
#line 193 "postler-accounts.vala"
					if (domain != NULL) {
#line 193 "postler-accounts.vala"
						_tmp6_ = g_utf8_next_char (domain);
#line 932 "postler-accounts.c"
					} else {
#line 193 "postler-accounts.vala"
						_tmp6_ = NULL;
#line 936 "postler-accounts.c"
					}
#line 193 "postler-accounts.vala"
					domain = (_tmp7_ = g_strdup (_tmp6_), _g_free0 (domain), _tmp7_);
#line 194 "postler-accounts.vala"
					if (domain != NULL) {
#line 942 "postler-accounts.c"
						char** _tmp8_;
						char** _tmp9_;
						gint _tmp9__length1;
						char* _tmp10_;
#line 195 "postler-accounts.vala"
						domain = (_tmp10_ = g_strdup ((_tmp9_ = _tmp8_ = g_strsplit (domain, ".", 2), _tmp9__length1 = _vala_array_length (_tmp8_), _tmp9_)[0]), _g_free0 (domain), _tmp10_);
#line 949 "postler-accounts.c"
						_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
					}
				}
#line 197 "postler-accounts.vala"
				_tmp11_ = g_strdup (domain);
#line 197 "postler-accounts.vala"
				if (_tmp11_ == NULL) {
#line 957 "postler-accounts.c"
					char* _tmp12_;
#line 197 "postler-accounts.vala"
					_tmp11_ = (_tmp12_ = g_strdup (info->name), _g_free0 (_tmp11_), _tmp12_);
#line 961 "postler-accounts.c"
				}
#line 197 "postler-accounts.vala"
				info->display_name = (_tmp13_ = g_strdup (_tmp11_), _g_free0 (info->display_name), _tmp13_);
#line 965 "postler-accounts.c"
				_g_free0 (_tmp11_);
				_g_free0 (domain);
				_g_free0 (_tmp0_);
				_g_object_unref0 (info);
			}
		}
	}
#line 199 "postler-accounts.vala"
	if (num_accounts == 1) {
#line 975 "postler-accounts.c"
		{
			GList* info_collection;
			GList* info_it;
#line 200 "postler-accounts.vala"
			info_collection = self->priv->infos;
#line 981 "postler-accounts.c"
			for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
				PostlerAccountInfo* info;
#line 200 "postler-accounts.vala"
				info = _g_object_ref0 ((PostlerAccountInfo*) info_it->data);
#line 986 "postler-accounts.c"
				{
#line 201 "postler-accounts.vala"
					if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
#line 990 "postler-accounts.c"
						char* _tmp14_;
#line 202 "postler-accounts.vala"
						info->display_name = (_tmp14_ = g_strdup (_ ("Inbox")), _g_free0 (info->display_name), _tmp14_);
#line 994 "postler-accounts.c"
					}
					_g_object_unref0 (info);
				}
			}
		}
	}
}


#line 205 "postler-accounts.vala"
static void postler_accounts_write_keyfile (PostlerAccounts* self, GError** error) {
#line 1006 "postler-accounts.c"
	char* _tmp0_;
	const char* config_dir;
	const char* indicator_dir;
	char* indicator_path;
	char* filename;
	gboolean exists;
	gboolean _tmp1_ = FALSE;
	char* autostart_path;
	char* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
#line 205 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 206 "postler-accounts.vala"
	if (g_mkdir_with_parents (self->priv->config_path, 0700) != 0) {
#line 1022 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Config folder couldn't be created."));
		{
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
#line 208 "postler-accounts.vala"
	g_file_set_contents (self->priv->account_file, _tmp0_ = g_key_file_to_data (self->priv->keyfile, NULL, NULL), -1, &_inner_error_);
#line 1031 "postler-accounts.c"
	_g_free0 (_tmp0_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 210 "postler-accounts.vala"
	config_dir = g_get_user_config_dir ();
#line 211 "postler-accounts.vala"
	indicator_dir = "/indicators/messages/applications";
#line 212 "postler-accounts.vala"
	indicator_path = g_strconcat (config_dir, indicator_dir, NULL);
#line 213 "postler-accounts.vala"
	filename = g_strconcat (indicator_path, "/postler.desktop", NULL);
#line 214 "postler-accounts.vala"
	exists = g_file_test (filename, G_FILE_TEST_EXISTS);
#line 215 "postler-accounts.vala"
	if (g_list_length (self->priv->infos) != 0) {
#line 215 "postler-accounts.vala"
		_tmp1_ = !exists;
#line 1051 "postler-accounts.c"
	} else {
#line 215 "postler-accounts.vala"
		_tmp1_ = FALSE;
#line 1055 "postler-accounts.c"
	}
#line 215 "postler-accounts.vala"
	if (_tmp1_) {
#line 216 "postler-accounts.vala"
		g_mkdir_with_parents (indicator_path, 0700);
#line 217 "postler-accounts.vala"
		g_file_set_contents (filename, MDATADIR "/applications/postler.desktop", -1, &_inner_error_);
#line 1063 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (filename);
			_g_free0 (indicator_path);
			return;
		}
	} else {
#line 220 "postler-accounts.vala"
		if (g_list_length (self->priv->infos) == 0) {
#line 221 "postler-accounts.vala"
			g_unlink (filename);
#line 1075 "postler-accounts.c"
		}
	}
#line 223 "postler-accounts.vala"
	autostart_path = g_strconcat (config_dir, "/autostart", NULL);
#line 224 "postler-accounts.vala"
	filename = (_tmp2_ = g_strconcat (autostart_path, "/postler.desktop", NULL), _g_free0 (filename), _tmp2_);
#line 225 "postler-accounts.vala"
	exists = g_file_test (filename, G_FILE_TEST_EXISTS);
#line 226 "postler-accounts.vala"
	if (g_list_length (self->priv->infos) != 0) {
#line 226 "postler-accounts.vala"
		_tmp3_ = !exists;
#line 1088 "postler-accounts.c"
	} else {
#line 226 "postler-accounts.vala"
		_tmp3_ = FALSE;
#line 1092 "postler-accounts.c"
	}
#line 226 "postler-accounts.vala"
	if (_tmp3_) {
#line 227 "postler-accounts.vala"
		g_mkdir_with_parents (autostart_path, 0700);
#line 228 "postler-accounts.vala"
		g_file_set_contents (filename, "[Desktop Entry]\nVersion=1.0\nType=Application\nName=Postler\n" "Exec=postler -m service\nIcon=postler", -1, &_inner_error_);
#line 1100 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (autostart_path);
			_g_free0 (filename);
			_g_free0 (indicator_path);
			return;
		}
	} else {
#line 232 "postler-accounts.vala"
		if (g_list_length (self->priv->infos) == 0) {
#line 233 "postler-accounts.vala"
			g_unlink (filename);
#line 1113 "postler-accounts.c"
		}
	}
#line 235 "postler-accounts.vala"
	postler_accounts_update_display_names (self);
#line 1118 "postler-accounts.c"
	_g_free0 (autostart_path);
	_g_free0 (filename);
	_g_free0 (indicator_path);
}


#line 238 "postler-accounts.vala"
void postler_accounts_update (PostlerAccounts* self) {
#line 1127 "postler-accounts.c"
	GError * _inner_error_ = NULL;
#line 238 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 1131 "postler-accounts.c"
	{
		{
			GList* account_info_collection;
			GList* account_info_it;
#line 240 "postler-accounts.vala"
			account_info_collection = self->priv->infos;
#line 1138 "postler-accounts.c"
			for (account_info_it = account_info_collection; account_info_it != NULL; account_info_it = account_info_it->next) {
				PostlerAccountInfo* account_info;
#line 240 "postler-accounts.vala"
				account_info = _g_object_ref0 ((PostlerAccountInfo*) account_info_it->data);
#line 1143 "postler-accounts.c"
				{
					char* group;
#line 241 "postler-accounts.vala"
					group = g_strdup (account_info->name);
#line 242 "postler-accounts.vala"
					g_return_if_fail (group != NULL);
#line 244 "postler-accounts.vala"
					if (account_info->type == POSTLER_ACCOUNT_TYPE_MAILDIR) {
#line 1152 "postler-accounts.c"
						gboolean _tmp0_ = FALSE;
						gboolean _tmp1_ = FALSE;
#line 245 "postler-accounts.vala"
						g_key_file_set_string (self->priv->keyfile, group, "type", "maildir");
#line 246 "postler-accounts.vala"
						if (account_info->path != NULL) {
#line 247 "postler-accounts.vala"
							_tmp0_ = !string_contains (account_info->path, self->priv->data_path);
#line 1161 "postler-accounts.c"
						} else {
#line 246 "postler-accounts.vala"
							_tmp0_ = FALSE;
#line 1165 "postler-accounts.c"
						}
#line 246 "postler-accounts.vala"
						if (_tmp0_) {
#line 248 "postler-accounts.vala"
							g_key_file_set_string (self->priv->keyfile, group, "path", account_info->path);
#line 1171 "postler-accounts.c"
						}
#line 249 "postler-accounts.vala"
						if (account_info->hide != NULL) {
#line 250 "postler-accounts.vala"
							_tmp1_ = _vala_strcmp0 (account_info->hide, POSTLER_hide_folder_default) != 0;
#line 1177 "postler-accounts.c"
						} else {
#line 249 "postler-accounts.vala"
							_tmp1_ = FALSE;
#line 1181 "postler-accounts.c"
						}
#line 249 "postler-accounts.vala"
						if (_tmp1_) {
#line 251 "postler-accounts.vala"
							g_key_file_set_string (self->priv->keyfile, group, "hide", account_info->hide);
#line 1187 "postler-accounts.c"
						}
					} else {
#line 253 "postler-accounts.vala"
						if (account_info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
#line 1192 "postler-accounts.c"
							gboolean _tmp2_ = FALSE;
#line 254 "postler-accounts.vala"
							g_key_file_set_string (self->priv->keyfile, group, "type", "imap");
#line 255 "postler-accounts.vala"
							if (account_info->realname != NULL) {
#line 256 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "realname", account_info->realname);
#line 1200 "postler-accounts.c"
							}
#line 257 "postler-accounts.vala"
							if (account_info->address != NULL) {
#line 258 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "address", account_info->address);
#line 1206 "postler-accounts.c"
							}
#line 259 "postler-accounts.vala"
							if (account_info->username != NULL) {
#line 260 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "username", account_info->username);
#line 1212 "postler-accounts.c"
							}
#line 261 "postler-accounts.vala"
							if (account_info->password != NULL) {
#line 262 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "password", account_info->password);
#line 1218 "postler-accounts.c"
							}
#line 263 "postler-accounts.vala"
							if (account_info->prefix != NULL) {
#line 264 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "prefix", account_info->prefix);
#line 1224 "postler-accounts.c"
							}
#line 265 "postler-accounts.vala"
							if (account_info->receive != NULL) {
#line 266 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "receive", account_info->receive);
#line 1230 "postler-accounts.c"
							}
#line 267 "postler-accounts.vala"
							if (account_info->send != NULL) {
#line 268 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "send", account_info->send);
#line 1236 "postler-accounts.c"
							}
#line 269 "postler-accounts.vala"
							if (account_info->send_port != 0) {
#line 270 "postler-accounts.vala"
								g_key_file_set_integer (self->priv->keyfile, group, "send-port", account_info->send_port);
#line 1242 "postler-accounts.c"
							}
#line 271 "postler-accounts.vala"
							if (account_info->certificate != NULL) {
#line 272 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "certificate", account_info->certificate);
#line 1248 "postler-accounts.c"
							}
#line 274 "postler-accounts.vala"
							if (account_info->unverified) {
#line 275 "postler-accounts.vala"
								g_key_file_set_boolean (self->priv->keyfile, group, "unverified", TRUE);
#line 1254 "postler-accounts.c"
							}
#line 276 "postler-accounts.vala"
							if (account_info->reply != NULL) {
#line 277 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "reply", account_info->reply);
#line 1260 "postler-accounts.c"
							}
#line 278 "postler-accounts.vala"
							if (account_info->organization != NULL) {
#line 279 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "organization", account_info->organization);
#line 1266 "postler-accounts.c"
							}
#line 281 "postler-accounts.vala"
							if (account_info->signature != NULL) {
#line 282 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "signature", account_info->signature);
#line 1272 "postler-accounts.c"
							}
#line 284 "postler-accounts.vala"
							if (account_info->hide != NULL) {
#line 285 "postler-accounts.vala"
								_tmp2_ = _vala_strcmp0 (account_info->hide, POSTLER_hide_folder_default) != 0;
#line 1278 "postler-accounts.c"
							} else {
#line 284 "postler-accounts.vala"
								_tmp2_ = FALSE;
#line 1282 "postler-accounts.c"
							}
#line 284 "postler-accounts.vala"
							if (_tmp2_) {
#line 286 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "hide", account_info->hide);
#line 1288 "postler-accounts.c"
							}
							{
								gint type;
#line 287 "postler-accounts.vala"
								type = 0;
#line 1294 "postler-accounts.c"
								{
									gboolean _tmp3_;
#line 287 "postler-accounts.vala"
									_tmp3_ = TRUE;
#line 287 "postler-accounts.vala"
									while (TRUE) {
#line 287 "postler-accounts.vala"
										if (!_tmp3_) {
#line 287 "postler-accounts.vala"
											type++;
#line 1305 "postler-accounts.c"
										}
#line 287 "postler-accounts.vala"
										_tmp3_ = FALSE;
#line 287 "postler-accounts.vala"
										if (!(type < POSTLER_FOLDER_TYPE_MAX)) {
#line 287 "postler-accounts.vala"
											break;
#line 1313 "postler-accounts.c"
										}
#line 288 "postler-accounts.vala"
										if (account_info->folders[type] != NULL) {
#line 1317 "postler-accounts.c"
											char* _tmp4_;
											char* _tmp5_;
#line 289 "postler-accounts.vala"
											g_key_file_set_string (self->priv->keyfile, group, _tmp5_ = g_strconcat ("localized", _tmp4_ = g_strdup_printf ("%i", type), NULL), account_info->folders[type]);
#line 1322 "postler-accounts.c"
											_g_free0 (_tmp5_);
											_g_free0 (_tmp4_);
										}
									}
								}
							}
						} else {
#line 294 "postler-accounts.vala"
							if (account_info->type == POSTLER_ACCOUNT_TYPE_SEARCH) {
#line 295 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "type", "search");
#line 296 "postler-accounts.vala"
								g_key_file_set_string (self->priv->keyfile, group, "path", account_info->path);
#line 1336 "postler-accounts.c"
							} else {
#line 299 "postler-accounts.vala"
								g_assert_not_reached ();
#line 1340 "postler-accounts.c"
							}
						}
					}
					_g_free0 (group);
					_g_object_unref0 (account_info);
				}
			}
		}
#line 302 "postler-accounts.vala"
		postler_accounts_write_keyfile (self, &_inner_error_);
#line 1351 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			goto __catch11_g_error;
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 305 "postler-accounts.vala"
			g_critical ("postler-accounts.vala:305: Failed to save \"%s\": %s", self->priv->account_file, _error_->message);
#line 1365 "postler-accounts.c"
			_g_error_free0 (_error_);
		}
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 309 "postler-accounts.vala"
static gboolean postler_accounts_remove_path (PostlerAccounts* self, const char* path, GError** error) {
#line 1380 "postler-accounts.c"
	gboolean result = FALSE;
	GDir* dir;
	char* name;
	GError * _inner_error_ = NULL;
#line 309 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 309 "postler-accounts.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1389 "postler-accounts.c"
	dir = NULL;
	{
		GDir* _tmp0_;
		GDir* _tmp1_;
#line 312 "postler-accounts.vala"
		_tmp0_ = g_dir_open (path, (guint) 0, &_inner_error_);
#line 1396 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			goto __catch12_g_error;
		}
#line 312 "postler-accounts.vala"
		dir = (_tmp1_ = _tmp0_, _g_dir_close0 (dir), _tmp1_);
#line 1402 "postler-accounts.c"
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
			result = g_remove (path) == 0;
			_g_error_free0 (_error_);
			_g_dir_close0 (dir);
#line 315 "postler-accounts.vala"
			return result;
#line 1416 "postler-accounts.c"
		}
	}
	__finally12:
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_dir_close0 (dir);
			return FALSE;
		} else {
			_g_dir_close0 (dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	name = NULL;
#line 318 "postler-accounts.vala"
	while (TRUE) {
#line 1435 "postler-accounts.c"
		char* _tmp2_;
		char* subpath;
		gboolean _tmp3_;
#line 318 "postler-accounts.vala"
		if (!((name = (_tmp2_ = g_strdup (g_dir_read_name (dir)), _g_free0 (name), _tmp2_)) != NULL)) {
#line 318 "postler-accounts.vala"
			break;
#line 1443 "postler-accounts.c"
		}
#line 319 "postler-accounts.vala"
		subpath = g_build_filename (path, name, NULL);
#line 320 "postler-accounts.vala"
		_tmp3_ = postler_accounts_remove_path (self, subpath, &_inner_error_);
#line 1449 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (subpath);
				_g_free0 (name);
				_g_dir_close0 (dir);
				return FALSE;
			} else {
				_g_free0 (subpath);
				_g_free0 (name);
				_g_dir_close0 (dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return FALSE;
			}
		}
#line 320 "postler-accounts.vala"
		if (!_tmp3_) {
#line 1468 "postler-accounts.c"
			result = FALSE;
			_g_free0 (subpath);
			_g_free0 (name);
			_g_dir_close0 (dir);
#line 321 "postler-accounts.vala"
			return result;
#line 1475 "postler-accounts.c"
		}
		_g_free0 (subpath);
	}
	result = g_remove (path) == 0;
	_g_free0 (name);
	_g_dir_close0 (dir);
#line 323 "postler-accounts.vala"
	return result;
#line 1484 "postler-accounts.c"
}


#line 326 "postler-accounts.vala"
static void postler_accounts_delete_account (PostlerAccounts* self, PostlerAccountInfo* info) {
#line 1490 "postler-accounts.c"
	GError * _inner_error_ = NULL;
#line 326 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 326 "postler-accounts.vala"
	g_return_if_fail (info != NULL);
#line 1496 "postler-accounts.c"
	g_return_if_fail (info->name != NULL);
	{
#line 329 "postler-accounts.vala"
		if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
#line 1501 "postler-accounts.c"
			gboolean _tmp0_;
#line 330 "postler-accounts.vala"
			_tmp0_ = postler_accounts_remove_path (self, info->path, &_inner_error_);
#line 1505 "postler-accounts.c"
			if (_inner_error_ != NULL) {
				goto __catch13_g_error;
			}
#line 330 "postler-accounts.vala"
			if (!_tmp0_) {
#line 1511 "postler-accounts.c"
				char* _tmp1_;
				GError* _tmp2_;
				_inner_error_ = (_tmp2_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp1_ = g_strdup_printf (_ ("Failed to remove \"%s\""), info->path)), _g_free0 (_tmp1_), _tmp2_);
				{
					goto __catch13_g_error;
				}
			}
		}
#line 334 "postler-accounts.vala"
		g_key_file_remove_group (self->priv->keyfile, info->name, &_inner_error_);
#line 1522 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			goto __catch13_g_error;
		}
#line 335 "postler-accounts.vala"
		postler_accounts_write_keyfile (self, &_inner_error_);
#line 1528 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			goto __catch13_g_error;
		}
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 338 "postler-accounts.vala"
			g_critical ("postler-accounts.vala:338: Failed to save \"%s\": %s", self->priv->account_file, _error_->message);
#line 1542 "postler-accounts.c"
			_g_error_free0 (_error_);
		}
	}
	__finally13:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 342 "postler-accounts.vala"
static void postler_accounts_reload (PostlerAccounts* self) {
#line 1557 "postler-accounts.c"
	GList* _tmp0_;
	GKeyFile* _tmp1_;
	GError * _inner_error_ = NULL;
#line 342 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 343 "postler-accounts.vala"
	self->priv->infos = (_tmp0_ = NULL, __g_list_free_g_object_unref0 (self->priv->infos), _tmp0_);
#line 344 "postler-accounts.vala"
	self->priv->keyfile = (_tmp1_ = g_key_file_new (), _g_key_file_free0 (self->priv->keyfile), _tmp1_);
#line 1567 "postler-accounts.c"
	{
#line 346 "postler-accounts.vala"
		g_key_file_load_from_file (self->priv->keyfile, self->priv->account_file, 0, &_inner_error_);
#line 1571 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			goto __catch14_g_error;
		}
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 349 "postler-accounts.vala"
			g_debug ("postler-accounts.vala:349: Failed to load \"%s\": %s", self->priv->account_file, _error_->message);
#line 1585 "postler-accounts.c"
			_g_error_free0 (_error_);
		}
	}
	__finally14:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		gsize _tmp2_;
		char** group_collection;
		int group_collection_length1;
		int group_it;
#line 352 "postler-accounts.vala"
		group_collection = g_key_file_get_groups (self->priv->keyfile, &_tmp2_);
#line 1602 "postler-accounts.c"
		group_collection_length1 = _tmp2_;
		for (group_it = 0; group_it < _tmp2_; group_it = group_it + 1) {
			char* group;
			group = g_strdup (group_collection[group_it]);
			{
				{
					char* type;
					PostlerAccountInfo* info;
					char* _tmp3_;
#line 354 "postler-accounts.vala"
					type = g_key_file_get_string (self->priv->keyfile, group, "type", &_inner_error_);
#line 1614 "postler-accounts.c"
					if (_inner_error_ != NULL) {
						goto __catch15_g_error;
					}
#line 355 "postler-accounts.vala"
					info = postler_account_info_new ();
#line 356 "postler-accounts.vala"
					info->name = (_tmp3_ = g_strdup (group), _g_free0 (info->name), _tmp3_);
#line 357 "postler-accounts.vala"
					if (_vala_strcmp0 (type, "maildir") == 0) {
#line 1624 "postler-accounts.c"
						gboolean _tmp4_;
						gboolean _tmp8_;
#line 358 "postler-accounts.vala"
						info->type = POSTLER_ACCOUNT_TYPE_MAILDIR;
#line 359 "postler-accounts.vala"
						_tmp4_ = g_key_file_has_key (self->priv->keyfile, group, "path", &_inner_error_);
#line 1631 "postler-accounts.c"
						if (_inner_error_ != NULL) {
							_g_object_unref0 (info);
							_g_free0 (type);
							goto __catch15_g_error;
						}
#line 359 "postler-accounts.vala"
						if (_tmp4_) {
#line 1639 "postler-accounts.c"
							char* _tmp5_;
							char* _tmp6_;
#line 360 "postler-accounts.vala"
							_tmp5_ = g_key_file_get_string (self->priv->keyfile, group, "path", &_inner_error_);
#line 1644 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 360 "postler-accounts.vala"
							info->path = (_tmp6_ = _tmp5_, _g_free0 (info->path), _tmp6_);
#line 1652 "postler-accounts.c"
						} else {
							char* _tmp7_;
#line 362 "postler-accounts.vala"
							info->path = (_tmp7_ = g_strconcat (self->priv->data_path, info->name, NULL), _g_free0 (info->path), _tmp7_);
#line 1657 "postler-accounts.c"
						}
#line 363 "postler-accounts.vala"
						_tmp8_ = g_key_file_has_key (self->priv->keyfile, group, "hide", &_inner_error_);
#line 1661 "postler-accounts.c"
						if (_inner_error_ != NULL) {
							_g_object_unref0 (info);
							_g_free0 (type);
							goto __catch15_g_error;
						}
#line 363 "postler-accounts.vala"
						if (_tmp8_) {
#line 1669 "postler-accounts.c"
							char* _tmp9_;
							char* _tmp10_;
#line 364 "postler-accounts.vala"
							_tmp9_ = g_key_file_get_string (self->priv->keyfile, group, "hide", &_inner_error_);
#line 1674 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 364 "postler-accounts.vala"
							info->hide = (_tmp10_ = _tmp9_, _g_free0 (info->hide), _tmp10_);
#line 1682 "postler-accounts.c"
						}
					} else {
#line 366 "postler-accounts.vala"
						if (_vala_strcmp0 (type, "imap") == 0) {
#line 1687 "postler-accounts.c"
							char* _tmp11_;
							gboolean _tmp12_;
							gboolean _tmp15_;
							gboolean _tmp18_;
							gboolean _tmp21_;
							gboolean _tmp24_;
							gboolean _tmp27_;
							gboolean _tmp30_;
							gboolean _tmp33_;
							gboolean _tmp35_;
							gboolean _tmp38_;
							gboolean _tmp40_;
							gboolean _tmp43_;
							gboolean _tmp46_;
							gboolean _tmp49_;
#line 367 "postler-accounts.vala"
							info->type = POSTLER_ACCOUNT_TYPE_IMAP;
#line 368 "postler-accounts.vala"
							info->path = (_tmp11_ = g_strconcat (self->priv->data_path, info->name, NULL), _g_free0 (info->path), _tmp11_);
#line 369 "postler-accounts.vala"
							_tmp12_ = g_key_file_has_key (self->priv->keyfile, group, "realname", &_inner_error_);
#line 1709 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 369 "postler-accounts.vala"
							if (_tmp12_) {
#line 1717 "postler-accounts.c"
								char* _tmp13_;
								char* _tmp14_;
#line 370 "postler-accounts.vala"
								_tmp13_ = g_key_file_get_string (self->priv->keyfile, group, "realname", &_inner_error_);
#line 1722 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 370 "postler-accounts.vala"
								info->realname = (_tmp14_ = _tmp13_, _g_free0 (info->realname), _tmp14_);
#line 1730 "postler-accounts.c"
							}
#line 371 "postler-accounts.vala"
							_tmp15_ = g_key_file_has_key (self->priv->keyfile, group, "address", &_inner_error_);
#line 1734 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 371 "postler-accounts.vala"
							if (_tmp15_) {
#line 1742 "postler-accounts.c"
								char* _tmp16_;
								char* _tmp17_;
#line 372 "postler-accounts.vala"
								_tmp16_ = g_key_file_get_string (self->priv->keyfile, group, "address", &_inner_error_);
#line 1747 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 372 "postler-accounts.vala"
								info->address = (_tmp17_ = _tmp16_, _g_free0 (info->address), _tmp17_);
#line 1755 "postler-accounts.c"
							}
#line 373 "postler-accounts.vala"
							_tmp18_ = g_key_file_has_key (self->priv->keyfile, group, "username", &_inner_error_);
#line 1759 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 373 "postler-accounts.vala"
							if (_tmp18_) {
#line 1767 "postler-accounts.c"
								char* _tmp19_;
								char* _tmp20_;
#line 374 "postler-accounts.vala"
								_tmp19_ = g_key_file_get_string (self->priv->keyfile, group, "username", &_inner_error_);
#line 1772 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 374 "postler-accounts.vala"
								info->username = (_tmp20_ = _tmp19_, _g_free0 (info->username), _tmp20_);
#line 1780 "postler-accounts.c"
							}
#line 375 "postler-accounts.vala"
							_tmp21_ = g_key_file_has_key (self->priv->keyfile, group, "password", &_inner_error_);
#line 1784 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 375 "postler-accounts.vala"
							if (_tmp21_) {
#line 1792 "postler-accounts.c"
								char* _tmp22_;
								char* _tmp23_;
#line 376 "postler-accounts.vala"
								_tmp22_ = g_key_file_get_string (self->priv->keyfile, group, "password", &_inner_error_);
#line 1797 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 376 "postler-accounts.vala"
								info->password = (_tmp23_ = _tmp22_, _g_free0 (info->password), _tmp23_);
#line 1805 "postler-accounts.c"
							}
#line 377 "postler-accounts.vala"
							_tmp24_ = g_key_file_has_key (self->priv->keyfile, group, "prefix", &_inner_error_);
#line 1809 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 377 "postler-accounts.vala"
							if (_tmp24_) {
#line 1817 "postler-accounts.c"
								char* _tmp25_;
								char* _tmp26_;
#line 378 "postler-accounts.vala"
								_tmp25_ = g_key_file_get_string (self->priv->keyfile, group, "prefix", &_inner_error_);
#line 1822 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 378 "postler-accounts.vala"
								info->prefix = (_tmp26_ = _tmp25_, _g_free0 (info->prefix), _tmp26_);
#line 1830 "postler-accounts.c"
							}
#line 379 "postler-accounts.vala"
							_tmp27_ = g_key_file_has_key (self->priv->keyfile, group, "receive", &_inner_error_);
#line 1834 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 379 "postler-accounts.vala"
							if (_tmp27_) {
#line 1842 "postler-accounts.c"
								char* _tmp28_;
								char* _tmp29_;
#line 380 "postler-accounts.vala"
								_tmp28_ = g_key_file_get_string (self->priv->keyfile, group, "receive", &_inner_error_);
#line 1847 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 380 "postler-accounts.vala"
								info->receive = (_tmp29_ = _tmp28_, _g_free0 (info->receive), _tmp29_);
#line 1855 "postler-accounts.c"
							}
#line 381 "postler-accounts.vala"
							_tmp30_ = g_key_file_has_key (self->priv->keyfile, group, "send", &_inner_error_);
#line 1859 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 381 "postler-accounts.vala"
							if (_tmp30_) {
#line 1867 "postler-accounts.c"
								char* _tmp31_;
								char* _tmp32_;
#line 382 "postler-accounts.vala"
								_tmp31_ = g_key_file_get_string (self->priv->keyfile, group, "send", &_inner_error_);
#line 1872 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 382 "postler-accounts.vala"
								info->send = (_tmp32_ = _tmp31_, _g_free0 (info->send), _tmp32_);
#line 1880 "postler-accounts.c"
							}
#line 383 "postler-accounts.vala"
							_tmp33_ = g_key_file_has_key (self->priv->keyfile, group, "send-port", &_inner_error_);
#line 1884 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 383 "postler-accounts.vala"
							if (_tmp33_) {
#line 1892 "postler-accounts.c"
								gint _tmp34_;
#line 384 "postler-accounts.vala"
								_tmp34_ = g_key_file_get_integer (self->priv->keyfile, group, "send-port", &_inner_error_);
#line 1896 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 384 "postler-accounts.vala"
								info->send_port = _tmp34_;
#line 1904 "postler-accounts.c"
							}
#line 385 "postler-accounts.vala"
							_tmp35_ = g_key_file_has_key (self->priv->keyfile, group, "certificate", &_inner_error_);
#line 1908 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 385 "postler-accounts.vala"
							if (_tmp35_) {
#line 1916 "postler-accounts.c"
								char* _tmp36_;
								char* _tmp37_;
#line 386 "postler-accounts.vala"
								_tmp36_ = g_key_file_get_string (self->priv->keyfile, group, "certificate", &_inner_error_);
#line 1921 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 386 "postler-accounts.vala"
								info->certificate = (_tmp37_ = _tmp36_, _g_free0 (info->certificate), _tmp37_);
#line 1929 "postler-accounts.c"
							}
#line 387 "postler-accounts.vala"
							_tmp38_ = g_key_file_has_key (self->priv->keyfile, group, "unverified", &_inner_error_);
#line 1933 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 387 "postler-accounts.vala"
							if (_tmp38_) {
#line 1941 "postler-accounts.c"
								gboolean _tmp39_;
#line 388 "postler-accounts.vala"
								_tmp39_ = g_key_file_get_boolean (self->priv->keyfile, group, "unverified", &_inner_error_);
#line 1945 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 388 "postler-accounts.vala"
								info->unverified = _tmp39_;
#line 1953 "postler-accounts.c"
							}
#line 389 "postler-accounts.vala"
							_tmp40_ = g_key_file_has_key (self->priv->keyfile, group, "reply", &_inner_error_);
#line 1957 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 389 "postler-accounts.vala"
							if (_tmp40_) {
#line 1965 "postler-accounts.c"
								char* _tmp41_;
								char* _tmp42_;
#line 390 "postler-accounts.vala"
								_tmp41_ = g_key_file_get_string (self->priv->keyfile, group, "reply", &_inner_error_);
#line 1970 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 390 "postler-accounts.vala"
								info->reply = (_tmp42_ = _tmp41_, _g_free0 (info->reply), _tmp42_);
#line 1978 "postler-accounts.c"
							}
#line 391 "postler-accounts.vala"
							_tmp43_ = g_key_file_has_key (self->priv->keyfile, group, "organization", &_inner_error_);
#line 1982 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 391 "postler-accounts.vala"
							if (_tmp43_) {
#line 1990 "postler-accounts.c"
								char* _tmp44_;
								char* _tmp45_;
#line 392 "postler-accounts.vala"
								_tmp44_ = g_key_file_get_string (self->priv->keyfile, group, "organization", &_inner_error_);
#line 1995 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 392 "postler-accounts.vala"
								info->organization = (_tmp45_ = _tmp44_, _g_free0 (info->organization), _tmp45_);
#line 2003 "postler-accounts.c"
							}
#line 393 "postler-accounts.vala"
							_tmp46_ = g_key_file_has_key (self->priv->keyfile, group, "signature", &_inner_error_);
#line 2007 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 393 "postler-accounts.vala"
							if (_tmp46_) {
#line 2015 "postler-accounts.c"
								char* _tmp47_;
								char* _tmp48_;
#line 394 "postler-accounts.vala"
								_tmp47_ = g_key_file_get_string (self->priv->keyfile, group, "signature", &_inner_error_);
#line 2020 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 394 "postler-accounts.vala"
								info->signature = (_tmp48_ = _tmp47_, _g_free0 (info->signature), _tmp48_);
#line 2028 "postler-accounts.c"
							}
#line 395 "postler-accounts.vala"
							_tmp49_ = g_key_file_has_key (self->priv->keyfile, group, "hide", &_inner_error_);
#line 2032 "postler-accounts.c"
							if (_inner_error_ != NULL) {
								_g_object_unref0 (info);
								_g_free0 (type);
								goto __catch15_g_error;
							}
#line 395 "postler-accounts.vala"
							if (_tmp49_) {
#line 2040 "postler-accounts.c"
								char* _tmp50_;
								char* _tmp51_;
#line 396 "postler-accounts.vala"
								_tmp50_ = g_key_file_get_string (self->priv->keyfile, group, "hide", &_inner_error_);
#line 2045 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 396 "postler-accounts.vala"
								info->hide = (_tmp51_ = _tmp50_, _g_free0 (info->hide), _tmp51_);
#line 2053 "postler-accounts.c"
							}
							{
								gint ftype;
#line 397 "postler-accounts.vala"
								ftype = 0;
#line 2059 "postler-accounts.c"
								{
									gboolean _tmp52_;
#line 397 "postler-accounts.vala"
									_tmp52_ = TRUE;
#line 397 "postler-accounts.vala"
									while (TRUE) {
#line 2066 "postler-accounts.c"
										char* _tmp53_;
										char* _tmp54_;
										char* keyname;
										gboolean _tmp55_;
#line 397 "postler-accounts.vala"
										if (!_tmp52_) {
#line 397 "postler-accounts.vala"
											ftype++;
#line 2075 "postler-accounts.c"
										}
#line 397 "postler-accounts.vala"
										_tmp52_ = FALSE;
#line 397 "postler-accounts.vala"
										if (!(ftype < POSTLER_FOLDER_TYPE_MAX)) {
#line 397 "postler-accounts.vala"
											break;
#line 2083 "postler-accounts.c"
										}
#line 398 "postler-accounts.vala"
										keyname = (_tmp54_ = g_strconcat ("localized", _tmp53_ = g_strdup_printf ("%i", ftype), NULL), _g_free0 (_tmp53_), _tmp54_);
#line 399 "postler-accounts.vala"
										_tmp55_ = g_key_file_has_key (self->priv->keyfile, group, keyname, &_inner_error_);
#line 2089 "postler-accounts.c"
										if (_inner_error_ != NULL) {
											_g_free0 (keyname);
											_g_object_unref0 (info);
											_g_free0 (type);
											goto __catch15_g_error;
										}
#line 399 "postler-accounts.vala"
										if (_tmp55_) {
#line 2098 "postler-accounts.c"
											char* _tmp56_;
											char* _tmp57_;
#line 400 "postler-accounts.vala"
											_tmp56_ = g_key_file_get_string (self->priv->keyfile, group, keyname, &_inner_error_);
#line 2103 "postler-accounts.c"
											if (_inner_error_ != NULL) {
												_g_free0 (keyname);
												_g_object_unref0 (info);
												_g_free0 (type);
												goto __catch15_g_error;
											}
#line 400 "postler-accounts.vala"
											info->folders[ftype] = (_tmp57_ = _tmp56_, _g_free0 (info->folders[ftype]), _tmp57_);
#line 2112 "postler-accounts.c"
										}
										_g_free0 (keyname);
									}
								}
							}
						} else {
#line 403 "postler-accounts.vala"
							if (_vala_strcmp0 (type, "search") == 0) {
#line 2121 "postler-accounts.c"
								char* _tmp58_;
								char* _tmp59_;
#line 404 "postler-accounts.vala"
								info->type = POSTLER_ACCOUNT_TYPE_SEARCH;
#line 405 "postler-accounts.vala"
								_tmp58_ = g_key_file_get_string (self->priv->keyfile, group, "path", &_inner_error_);
#line 2128 "postler-accounts.c"
								if (_inner_error_ != NULL) {
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
#line 405 "postler-accounts.vala"
								info->path = (_tmp59_ = _tmp58_, _g_free0 (info->path), _tmp59_);
#line 2136 "postler-accounts.c"
							} else {
								char* _tmp60_;
								GError* _tmp61_;
								_inner_error_ = (_tmp61_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _tmp60_ = g_strdup_printf (_ ("Invalid type \"%s\""), type)), _g_free0 (_tmp60_), _tmp61_);
								{
									_g_object_unref0 (info);
									_g_free0 (type);
									goto __catch15_g_error;
								}
							}
						}
					}
#line 410 "postler-accounts.vala"
					self->priv->infos = g_list_prepend (self->priv->infos, _g_object_ref0 (info));
#line 2151 "postler-accounts.c"
					_g_object_unref0 (info);
					_g_free0 (type);
				}
				goto __finally15;
				__catch15_g_error:
				{
					GError * _error_;
					_error_ = _inner_error_;
					_inner_error_ = NULL;
					{
#line 413 "postler-accounts.vala"
						g_critical (_ ("Failed to parse account in \"%s\": %s"), self->priv->account_file, _error_->message);
#line 2164 "postler-accounts.c"
						_g_error_free0 (_error_);
					}
				}
				__finally15:
				if (_inner_error_ != NULL) {
					_g_free0 (group);
					group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_free0 (group);
			}
		}
#line 352 "postler-accounts.vala"
		group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2181 "postler-accounts.c"
	}
#line 417 "postler-accounts.vala"
	self->priv->infos = g_list_reverse (self->priv->infos);
#line 418 "postler-accounts.vala"
	postler_accounts_update_display_names (self);
#line 2187 "postler-accounts.c"
}


static void _vala_array_add1 (char*** array, int* length, int* size, char* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (char*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 421 "postler-accounts.vala"
char** postler_accounts_get_folders (PostlerAccounts* self, int* result_length1) {
#line 2203 "postler-accounts.c"
	char** result = NULL;
	gint folders_length1;
	gint _folders_size_;
	char** _tmp1_;
	char** _tmp0_ = NULL;
	char** folders;
	char** _tmp2_;
#line 421 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2213 "postler-accounts.c"
	folders = (_tmp1_ = (_tmp0_ = g_new0 (char*, 0 + 1), _tmp0_), folders_length1 = 0, _folders_size_ = folders_length1, _tmp1_);
	{
		GList* info_collection;
		GList* info_it;
#line 423 "postler-accounts.vala"
		info_collection = self->priv->infos;
#line 2220 "postler-accounts.c"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			PostlerAccountInfo* info;
#line 423 "postler-accounts.vala"
			info = (PostlerAccountInfo*) info_it->data;
#line 2225 "postler-accounts.c"
			{
#line 424 "postler-accounts.vala"
				if (info->type != POSTLER_ACCOUNT_TYPE_SEARCH) {
#line 425 "postler-accounts.vala"
					_vala_array_add1 (&folders, &folders_length1, &_folders_size_, g_strdup (info->path));
#line 2231 "postler-accounts.c"
				}
			}
		}
	}
	result = (_tmp2_ = folders, *result_length1 = folders_length1, _tmp2_);
#line 427 "postler-accounts.vala"
	return result;
#line 2239 "postler-accounts.c"
	folders = (_vala_array_free (folders, folders_length1, (GDestroyNotify) g_free), NULL);
}


#line 430 "postler-accounts.vala"
GList* postler_accounts_get_infos (PostlerAccounts* self) {
#line 2246 "postler-accounts.c"
	GList* result = NULL;
#line 430 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2250 "postler-accounts.c"
	result = self->priv->infos;
#line 431 "postler-accounts.vala"
	return result;
#line 2254 "postler-accounts.c"
}


#line 446 "postler-accounts.vala"
static char* postler_accounts_get_tool_configfile (PostlerAccounts* self, const char* send, PostlerAccountInfo* info, GError** error) {
#line 2260 "postler-accounts.c"
	char* result = NULL;
	const char* cache_dir;
	char* cache_path;
	GError * _inner_error_ = NULL;
#line 446 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 446 "postler-accounts.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 447 "postler-accounts.vala"
	cache_dir = g_get_user_cache_dir ();
#line 448 "postler-accounts.vala"
	cache_path = g_strconcat (cache_dir, "/postler/mail", NULL);
#line 449 "postler-accounts.vala"
	if (g_mkdir_with_parents (cache_path, 0700) != 0) {
#line 2275 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Cache folder couldn't be created."));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (cache_path);
				return NULL;
			} else {
				_g_free0 (cache_path);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 452 "postler-accounts.vala"
	if (send != NULL) {
#line 2292 "postler-accounts.c"
		result = g_strdup_printf ("%s/%s.msmtprc", cache_path, info->name);
		_g_free0 (cache_path);
#line 453 "postler-accounts.vala"
		return result;
#line 2297 "postler-accounts.c"
	}
#line 455 "postler-accounts.vala"
	switch (info->type) {
#line 2301 "postler-accounts.c"
		case POSTLER_ACCOUNT_TYPE_IMAP:
		{
			result = g_strdup_printf ("%s/%s.mbsyncrc", cache_path, info->name);
			_g_free0 (cache_path);
#line 457 "postler-accounts.vala"
			return result;
#line 2308 "postler-accounts.c"
		}
		case POSTLER_ACCOUNT_TYPE_MAILDIR:
		case POSTLER_ACCOUNT_TYPE_SEARCH:
		{
			_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("This type can't receive mail."));
			{
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (cache_path);
					return NULL;
				} else {
					_g_free0 (cache_path);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	result = NULL;
	_g_free0 (cache_path);
#line 462 "postler-accounts.vala"
	return result;
#line 2332 "postler-accounts.c"
}


#line 465 "postler-accounts.vala"
static char* postler_accounts_get_tool_configuration (PostlerAccounts* self, const char* send, PostlerAccountInfo* info, GError** error) {
#line 2338 "postler-accounts.c"
	char* result = NULL;
	char* filename;
	struct stat account_file_status = {0};
	struct stat filename_status = {0};
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	char* certificate;
	gboolean _tmp10_ = FALSE;
	gint hidden_tmp_length1;
	gint _hidden_tmp_size_;
	char** _tmp14_;
	char** _tmp13_;
	char** hidden_tmp;
	char* hidden_folders;
	GError * _inner_error_ = NULL;
#line 465 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 465 "postler-accounts.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 466 "postler-accounts.vala"
	filename = postler_accounts_get_tool_configfile (self, send, info, &_inner_error_);
#line 2360 "postler-accounts.c"
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
#line 470 "postler-accounts.vala"
	stat (self->priv->account_file, &account_file_status);
#line 472 "postler-accounts.vala"
	stat (filename, &filename_status);
#line 473 "postler-accounts.vala"
	if (account_file_status.st_mtime < filename_status.st_mtime) {
#line 2377 "postler-accounts.c"
		result = filename;
#line 474 "postler-accounts.vala"
		return result;
#line 2381 "postler-accounts.c"
	}
#line 476 "postler-accounts.vala"
	if (self->priv->certificate_file == NULL) {
#line 2385 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("No SSL certificates available"));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 479 "postler-accounts.vala"
	if (info->address != NULL) {
#line 2402 "postler-accounts.c"
		gint address_parts_length1;
		gint _address_parts_size_;
		char** _tmp1_;
		char** _tmp0_;
		char** address_parts;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp5_ = FALSE;
		address_parts = (_tmp1_ = _tmp0_ = g_strsplit_set (info->address, "@,", 3), address_parts_length1 = _vala_array_length (_tmp0_), _address_parts_size_ = address_parts_length1, _tmp1_);
#line 481 "postler-accounts.vala"
		if (address_parts[0] == NULL) {
#line 481 "postler-accounts.vala"
			_tmp2_ = TRUE;
#line 2416 "postler-accounts.c"
		} else {
#line 481 "postler-accounts.vala"
			_tmp2_ = address_parts[1] == NULL;
#line 2420 "postler-accounts.c"
		}
#line 481 "postler-accounts.vala"
		if (_tmp2_) {
#line 2424 "postler-accounts.c"
			_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Invalid address"));
			{
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (filename);
					return NULL;
				} else {
					address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (filename);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
#line 483 "postler-accounts.vala"
		if (send == NULL) {
#line 483 "postler-accounts.vala"
			_tmp3_ = info->receive == NULL;
#line 2445 "postler-accounts.c"
		} else {
#line 483 "postler-accounts.vala"
			_tmp3_ = FALSE;
#line 2449 "postler-accounts.c"
		}
#line 483 "postler-accounts.vala"
		if (_tmp3_) {
#line 2453 "postler-accounts.c"
			char* _tmp4_;
#line 484 "postler-accounts.vala"
			info->receive = (_tmp4_ = g_strconcat ("imap.", address_parts[1], NULL), _g_free0 (info->receive), _tmp4_);
#line 2457 "postler-accounts.c"
		}
#line 485 "postler-accounts.vala"
		if (send != NULL) {
#line 485 "postler-accounts.vala"
			_tmp5_ = info->send == NULL;
#line 2463 "postler-accounts.c"
		} else {
#line 485 "postler-accounts.vala"
			_tmp5_ = FALSE;
#line 2467 "postler-accounts.c"
		}
#line 485 "postler-accounts.vala"
		if (_tmp5_) {
#line 2471 "postler-accounts.c"
			char* _tmp6_;
#line 486 "postler-accounts.vala"
			info->send = (_tmp6_ = g_strconcat ("smtp.", address_parts[1], NULL), _g_free0 (info->send), _tmp6_);
#line 2475 "postler-accounts.c"
		}
#line 487 "postler-accounts.vala"
		if (info->username == NULL) {
#line 2479 "postler-accounts.c"
			char* _tmp7_;
#line 488 "postler-accounts.vala"
			info->username = (_tmp7_ = g_strdup (address_parts[0]), _g_free0 (info->username), _tmp7_);
#line 2483 "postler-accounts.c"
		}
		address_parts = (_vala_array_free (address_parts, address_parts_length1, (GDestroyNotify) g_free), NULL);
	}
#line 491 "postler-accounts.vala"
	if (send == NULL) {
#line 491 "postler-accounts.vala"
		_tmp8_ = info->receive == NULL;
#line 2491 "postler-accounts.c"
	} else {
#line 491 "postler-accounts.vala"
		_tmp8_ = FALSE;
#line 2495 "postler-accounts.c"
	}
#line 491 "postler-accounts.vala"
	if (_tmp8_) {
#line 2499 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Hostname is missing"));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 493 "postler-accounts.vala"
	if (send != NULL) {
#line 493 "postler-accounts.vala"
		_tmp9_ = info->send == NULL;
#line 2518 "postler-accounts.c"
	} else {
#line 493 "postler-accounts.vala"
		_tmp9_ = FALSE;
#line 2522 "postler-accounts.c"
	}
#line 493 "postler-accounts.vala"
	if (_tmp9_) {
#line 2526 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Hostname is missing"));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 495 "postler-accounts.vala"
	if (info->username == NULL) {
#line 2543 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Username is missing"));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 497 "postler-accounts.vala"
	if (info->password == NULL) {
#line 2560 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Password is missing"));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 499 "postler-accounts.vala"
	certificate = g_strdup (info->certificate);
#line 500 "postler-accounts.vala"
	if (certificate != NULL) {
#line 500 "postler-accounts.vala"
		_tmp10_ = !g_path_is_absolute (certificate);
#line 2581 "postler-accounts.c"
	} else {
#line 500 "postler-accounts.vala"
		_tmp10_ = FALSE;
#line 2585 "postler-accounts.c"
	}
#line 500 "postler-accounts.vala"
	if (_tmp10_) {
#line 2589 "postler-accounts.c"
		char* _tmp11_;
		char* _tmp12_;
#line 501 "postler-accounts.vala"
		certificate = (_tmp12_ = g_strconcat (_tmp11_ = g_strconcat (info->path, "/", NULL), certificate, NULL), _g_free0 (certificate), _tmp12_);
#line 2594 "postler-accounts.c"
		_g_free0 (_tmp11_);
	}
	hidden_tmp = (_tmp14_ = _tmp13_ = g_strsplit (info->hide, ",", 0), hidden_tmp_length1 = _vala_array_length (_tmp13_), _hidden_tmp_size_ = hidden_tmp_length1, _tmp14_);
#line 505 "postler-accounts.vala"
	hidden_folders = g_strdup ("");
#line 2600 "postler-accounts.c"
	{
		char** hidden_collection;
		int hidden_collection_length1;
		int hidden_it;
#line 506 "postler-accounts.vala"
		hidden_collection = hidden_tmp;
#line 2607 "postler-accounts.c"
		hidden_collection_length1 = hidden_tmp_length1;
		for (hidden_it = 0; hidden_it < hidden_tmp_length1; hidden_it = hidden_it + 1) {
			char* hidden;
			hidden = g_strdup (hidden_collection[hidden_it]);
			{
#line 507 "postler-accounts.vala"
				if (string_contains (hidden, " ")) {
#line 2615 "postler-accounts.c"
					char* _tmp15_;
					char* _tmp16_;
					char* _tmp17_;
					char* _tmp18_;
#line 508 "postler-accounts.vala"
					hidden_folders = (_tmp18_ = g_strconcat (hidden_folders, _tmp17_ = g_strconcat (_tmp16_ = g_strconcat (" \"!", _tmp15_ = string_replace (hidden, "~-", "/"), NULL), "\"", NULL), NULL), _g_free0 (hidden_folders), _tmp18_);
#line 2622 "postler-accounts.c"
					_g_free0 (_tmp17_);
					_g_free0 (_tmp16_);
					_g_free0 (_tmp15_);
				} else {
					char* _tmp19_;
					char* _tmp20_;
#line 510 "postler-accounts.vala"
					hidden_folders = (_tmp20_ = g_strconcat (hidden_folders, _tmp19_ = g_strconcat (" !", hidden, NULL), NULL), _g_free0 (hidden_folders), _tmp20_);
#line 2631 "postler-accounts.c"
					_g_free0 (_tmp19_);
				}
				_g_free0 (hidden);
			}
		}
	}
#line 513 "postler-accounts.vala"
	if (send != NULL) {
#line 2640 "postler-accounts.c"
		char* tls_options;
		gint _tmp25_ = 0;
		char** _tmp26_;
		char** _tmp27_;
		gint _tmp27__length1;
		char** _tmp28_;
		char** _tmp29_;
		gint _tmp29__length1;
		char** _tmp30_;
		char** _tmp31_;
		gint _tmp31__length1;
		char* _tmp32_;
		char* msmtprc;
		tls_options = NULL;
#line 515 "postler-accounts.vala"
		if (info->unverified) {
#line 2657 "postler-accounts.c"
			char* _tmp21_;
#line 516 "postler-accounts.vala"
			tls_options = (_tmp21_ = g_strdup ("tls_certcheck off"), _g_free0 (tls_options), _tmp21_);
#line 2661 "postler-accounts.c"
		} else {
			const char* _tmp22_;
			char* _tmp23_;
			_tmp22_ = NULL;
#line 520 "postler-accounts.vala"
			if (certificate != NULL) {
#line 520 "postler-accounts.vala"
				_tmp22_ = certificate;
#line 2670 "postler-accounts.c"
			} else {
#line 520 "postler-accounts.vala"
				_tmp22_ = self->priv->certificate_file;
#line 2674 "postler-accounts.c"
			}
#line 518 "postler-accounts.vala"
			tls_options = (_tmp23_ = g_strdup_printf ("tls_trust_file %s\ntls_trust_file %s", self->priv->certificate_file, _tmp22_), _g_free0 (tls_options), _tmp23_);
#line 2678 "postler-accounts.c"
		}
#line 521 "postler-accounts.vala"
		if (info->send_port == 465) {
#line 2682 "postler-accounts.c"
			char* _tmp24_;
#line 522 "postler-accounts.vala"
			tls_options = (_tmp24_ = g_strconcat (tls_options, "\ntls_starttls off", NULL), _g_free0 (tls_options), _tmp24_);
#line 2686 "postler-accounts.c"
		}
#line 546 "postler-accounts.vala"
		if (info->send_port != 0) {
#line 546 "postler-accounts.vala"
			_tmp25_ = info->send_port;
#line 2692 "postler-accounts.c"
		} else {
#line 546 "postler-accounts.vala"
			_tmp25_ = 25;
#line 2696 "postler-accounts.c"
		}
#line 523 "postler-accounts.vala"
		msmtprc = (_tmp32_ = g_strdup_printf ("\n" \
"                defaults\n" \
"                auth on\n" \
"                tls on\n" \
"                %s\n" \
"                auto_from on\n" \
"                maildomain %s\n" \
"                account postler\n" \
"                host %s\n" \
"                from %s\n" \
"                user %s\n" \
"                password %s\n" \
"                port %d\n" \
"                timeout 90\n" \
"                account default : postler\n" \
"                ", tls_options, (_tmp29_ = _tmp28_ = g_strsplit ((_tmp27_ = _tmp26_ = g_strsplit (info->address, ",", 0), _tmp27__length1 = _vala_array_length (_tmp26_), _tmp27_)[0], "@", 0), _tmp29__length1 = _vala_array_length (_tmp28_), _tmp29_)[1], info->send, (_tmp31_ = _tmp30_ = g_strsplit (info->address, ",", 0), _tmp31__length1 = _vala_array_length (_tmp30_), _tmp31_)[0], info->username, info->password, _tmp25_), _tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_free), NULL), _tmp29_ = (_vala_array_free (_tmp29_, _tmp29__length1, (GDestroyNotify) g_free), NULL), _tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL), _tmp32_);
#line 548 "postler-accounts.vala"
		g_file_set_contents (filename, msmtprc, (gssize) (-1), &_inner_error_);
#line 2702 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msmtprc);
				_g_free0 (tls_options);
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				return NULL;
			} else {
				_g_free0 (msmtprc);
				_g_free0 (tls_options);
				_g_free0 (hidden_folders);
				hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (certificate);
				_g_free0 (filename);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
#line 549 "postler-accounts.vala"
		g_chmod (filename, 0600);
#line 2727 "postler-accounts.c"
		result = filename;
		_g_free0 (msmtprc);
		_g_free0 (tls_options);
		_g_free0 (hidden_folders);
		hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (certificate);
#line 550 "postler-accounts.vala"
		return result;
#line 2736 "postler-accounts.c"
	}
#line 553 "postler-accounts.vala"
	switch (info->type) {
#line 2740 "postler-accounts.c"
		case POSTLER_ACCOUNT_TYPE_IMAP:
		{
			char* _tmp33_;
			const char* _tmp36_;
			const char* _tmp37_;
			char* mbsyncrc;
			_tmp33_ = NULL;
#line 588 "postler-accounts.vala"
			if (info->prefix != NULL) {
#line 2750 "postler-accounts.c"
				char* _tmp34_;
#line 588 "postler-accounts.vala"
				_tmp33_ = (_tmp34_ = g_strconcat (info->prefix, ".", NULL), _g_free0 (_tmp33_), _tmp34_);
#line 2754 "postler-accounts.c"
			} else {
				char* _tmp35_;
#line 588 "postler-accounts.vala"
				_tmp33_ = (_tmp35_ = g_strdup (""), _g_free0 (_tmp33_), _tmp35_);
#line 2759 "postler-accounts.c"
			}
			_tmp36_ = NULL;
#line 590 "postler-accounts.vala"
			if (certificate != NULL) {
#line 590 "postler-accounts.vala"
				_tmp36_ = "CertificateFile";
#line 2766 "postler-accounts.c"
			} else {
#line 590 "postler-accounts.vala"
				_tmp36_ = "";
#line 2770 "postler-accounts.c"
			}
			_tmp37_ = NULL;
#line 591 "postler-accounts.vala"
			if (certificate != NULL) {
#line 591 "postler-accounts.vala"
				_tmp37_ = certificate;
#line 2777 "postler-accounts.c"
			} else {
#line 591 "postler-accounts.vala"
				_tmp37_ = "";
#line 2781 "postler-accounts.c"
			}
#line 555 "postler-accounts.vala"
			mbsyncrc = g_strdup_printf ("\n" \
"               Sync Pull\n" \
"               Create Slave\n" \
"               SyncState *\n" \
"\n" \
"               IMAPStore remote\n" \
"                   Host %s\n" \
"                   User %s\n" \
"                   Pass \"%s\"\n" \
"                   Path \"%s\"\n" \
"                   UseIMAPS yes\n" \
"                   CertificateFile %s\n" \
"                   %s %s\n" \
"\n" \
"               MaildirStore local\n" \
"                   Path %s/\n" \
"                   Inbox %s/INBOX\n" \
"\n" \
"               Channel local-remote\n" \
"                   Master :remote:\n" \
"                   Slave :local:\n" \
"                   Patterns %% * !INBOX.*\n" \
"                   Patterns %% %s\n" \
"                   MaxMessages 500\n" \
"\n" \
"               Group mirror\n" \
"                   Channel local-remote:INBOX\n" \
"                   Channel local-remote\n" \
"               ", info->receive, info->username, info->password, _tmp33_, self->priv->certificate_file, _tmp36_, _tmp37_, info->path, info->path, hidden_folders);
#line 596 "postler-accounts.vala"
			g_file_set_contents (filename, mbsyncrc, (gssize) (-1), &_inner_error_);
#line 2787 "postler-accounts.c"
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (mbsyncrc);
					_g_free0 (_tmp33_);
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					return NULL;
				} else {
					_g_free0 (mbsyncrc);
					_g_free0 (_tmp33_);
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
#line 597 "postler-accounts.vala"
			g_chmod (filename, 0700);
#line 2812 "postler-accounts.c"
			_g_free0 (mbsyncrc);
			_g_free0 (_tmp33_);
#line 598 "postler-accounts.vala"
			break;
#line 2817 "postler-accounts.c"
		}
		case POSTLER_ACCOUNT_TYPE_MAILDIR:
		case POSTLER_ACCOUNT_TYPE_SEARCH:
		{
			_inner_error_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Account \"%s\" can't receive mail."), info->name);
			{
				if (_inner_error_->domain == G_FILE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					return NULL;
				} else {
					_g_free0 (hidden_folders);
					hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (certificate);
					_g_free0 (filename);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	result = filename;
	_g_free0 (hidden_folders);
	hidden_tmp = (_vala_array_free (hidden_tmp, hidden_tmp_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (certificate);
#line 604 "postler-accounts.vala"
	return result;
#line 2849 "postler-accounts.c"
}


#line 607 "postler-accounts.vala"
char* postler_accounts_get_receive_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error) {
#line 2855 "postler-accounts.c"
	char* result = NULL;
	char* command;
	GError * _inner_error_ = NULL;
#line 607 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 607 "postler-accounts.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 2863 "postler-accounts.c"
	command = NULL;
#line 610 "postler-accounts.vala"
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
#line 2867 "postler-accounts.c"
		const char* mbsync;
		gboolean _tmp0_ = FALSE;
		char* filename;
		char* _tmp1_;
#line 611 "postler-accounts.vala"
		mbsync = g_getenv ("POSTLER_MBSYNC");
#line 612 "postler-accounts.vala"
		if (mbsync == NULL) {
#line 612 "postler-accounts.vala"
			_tmp0_ = TRUE;
#line 2878 "postler-accounts.c"
		} else {
#line 612 "postler-accounts.vala"
			_tmp0_ = _vala_strcmp0 (mbsync, "") == 0;
#line 2882 "postler-accounts.c"
		}
#line 612 "postler-accounts.vala"
		if (_tmp0_) {
#line 613 "postler-accounts.vala"
			mbsync = "postler-mbsync";
#line 2888 "postler-accounts.c"
		}
#line 614 "postler-accounts.vala"
		filename = postler_accounts_get_tool_configuration (self, NULL, info, &_inner_error_);
#line 2892 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
#line 615 "postler-accounts.vala"
		command = (_tmp1_ = g_strdup_printf ("%s -c %s --pull%s mirror", mbsync, filename, " --push --expunge"), _g_free0 (command), _tmp1_);
#line 2907 "postler-accounts.c"
		_g_free0 (filename);
	} else {
		_inner_error_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Account \"%s\" can't receive mail."), info->name);
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 622 "postler-accounts.vala"
	if (g_mkdir_with_parents (info->path, 0700) != 0) {
#line 2926 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Mail folder couldn't be created."));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	result = command;
#line 624 "postler-accounts.vala"
	return result;
#line 2944 "postler-accounts.c"
}


#line 627 "postler-accounts.vala"
char* postler_accounts_get_fetch_command (PostlerAccounts* self, PostlerAccountInfo* info, GError** error) {
#line 2950 "postler-accounts.c"
	char* result = NULL;
	char* command;
	GError * _inner_error_ = NULL;
#line 627 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 627 "postler-accounts.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 2958 "postler-accounts.c"
	command = NULL;
#line 630 "postler-accounts.vala"
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
#line 2962 "postler-accounts.c"
		const char* mbsync;
		gboolean _tmp0_ = FALSE;
		char* filename;
		char* _tmp1_;
#line 631 "postler-accounts.vala"
		mbsync = g_getenv ("POSTLER_MBSYNC");
#line 632 "postler-accounts.vala"
		if (mbsync == NULL) {
#line 632 "postler-accounts.vala"
			_tmp0_ = TRUE;
#line 2973 "postler-accounts.c"
		} else {
#line 632 "postler-accounts.vala"
			_tmp0_ = _vala_strcmp0 (mbsync, "") == 0;
#line 2977 "postler-accounts.c"
		}
#line 632 "postler-accounts.vala"
		if (_tmp0_) {
#line 633 "postler-accounts.vala"
			mbsync = "postler-mbsync";
#line 2983 "postler-accounts.c"
		}
#line 634 "postler-accounts.vala"
		filename = postler_accounts_get_tool_configuration (self, NULL, info, &_inner_error_);
#line 2987 "postler-accounts.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
#line 635 "postler-accounts.vala"
		command = (_tmp1_ = g_strdup_printf ("%s --list -c %s mirror", mbsync, filename), _g_free0 (command), _tmp1_);
#line 3002 "postler-accounts.c"
		_g_free0 (filename);
	} else {
		_inner_error_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Account \"%s\" can't receive mail."), info->name);
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
#line 642 "postler-accounts.vala"
	if (g_mkdir_with_parents (info->path, 0700) != 0) {
#line 3021 "postler-accounts.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Mail folder couldn't be created."));
		{
			if (_inner_error_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (command);
				return NULL;
			} else {
				_g_free0 (command);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
	}
	result = command;
#line 644 "postler-accounts.vala"
	return result;
#line 3039 "postler-accounts.c"
}


#line 647 "postler-accounts.vala"
char* postler_accounts_get_send_command (PostlerAccounts* self, PostlerAccountInfo* info, const char* send, GError** error) {
#line 3045 "postler-accounts.c"
	char* result = NULL;
	char* filename;
	char* command;
	GError * _inner_error_ = NULL;
#line 647 "postler-accounts.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 647 "postler-accounts.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 647 "postler-accounts.vala"
	g_return_val_if_fail (send != NULL, NULL);
#line 648 "postler-accounts.vala"
	filename = postler_accounts_get_tool_configuration (self, send, info, &_inner_error_);
#line 3058 "postler-accounts.c"
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
#line 649 "postler-accounts.vala"
	command = g_strdup_printf ("%s -c 'cat \"%s\" | msmtp -C %s -t'", g_getenv ("SHELL"), send, filename);
#line 3071 "postler-accounts.c"
	result = command;
	_g_free0 (filename);
#line 651 "postler-accounts.vala"
	return result;
#line 3076 "postler-accounts.c"
}


#line 434 "postler-accounts.vala"
static void postler_accounts_real_add_info (PostlerAccounts* self, PostlerAccountInfo* info) {
#line 434 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 434 "postler-accounts.vala"
	g_return_if_fail (info != NULL);
#line 435 "postler-accounts.vala"
	if (info->type == POSTLER_ACCOUNT_TYPE_IMAP) {
#line 3088 "postler-accounts.c"
		char* _tmp0_;
#line 436 "postler-accounts.vala"
		info->path = (_tmp0_ = g_strconcat (self->priv->data_path, info->name, NULL), _g_free0 (info->path), _tmp0_);
#line 3092 "postler-accounts.c"
	}
#line 437 "postler-accounts.vala"
	self->priv->infos = g_list_append (self->priv->infos, _g_object_ref0 (info));
#line 438 "postler-accounts.vala"
	postler_accounts_update (self);
#line 3098 "postler-accounts.c"
}


#line 441 "postler-accounts.vala"
static void postler_accounts_real_remove_info (PostlerAccounts* self, PostlerAccountInfo* info) {
#line 441 "postler-accounts.vala"
	g_return_if_fail (self != NULL);
#line 441 "postler-accounts.vala"
	g_return_if_fail (info != NULL);
#line 442 "postler-accounts.vala"
	self->priv->infos = g_list_remove (self->priv->infos, info);
#line 443 "postler-accounts.vala"
	postler_accounts_delete_account (self, info);
#line 3112 "postler-accounts.c"
}


static void postler_accounts_class_init (PostlerAccountsClass * klass) {
	postler_accounts_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PostlerAccountsPrivate));
	POSTLER_ACCOUNTS_CLASS (klass)->add_info = postler_accounts_real_add_info;
	POSTLER_ACCOUNTS_CLASS (klass)->remove_info = postler_accounts_real_remove_info;
	G_OBJECT_CLASS (klass)->finalize = postler_accounts_finalize;
	g_signal_new ("add_info", POSTLER_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PostlerAccountsClass, add_info), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POSTLER_TYPE_ACCOUNT_INFO);
	g_signal_new ("remove_info", POSTLER_TYPE_ACCOUNTS, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PostlerAccountsClass, remove_info), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POSTLER_TYPE_ACCOUNT_INFO);
}


static void postler_accounts_instance_init (PostlerAccounts * self) {
	self->priv = POSTLER_ACCOUNTS_GET_PRIVATE (self);
}


static void postler_accounts_finalize (GObject* obj) {
	PostlerAccounts * self;
	self = POSTLER_ACCOUNTS (obj);
	_g_free0 (self->priv->config_path);
	_g_free0 (self->priv->account_file);
	_g_free0 (self->priv->data_path);
	_g_free0 (self->priv->certificate_file);
	_g_key_file_free0 (self->priv->keyfile);
	__g_list_free_g_object_unref0 (self->priv->infos);
	G_OBJECT_CLASS (postler_accounts_parent_class)->finalize (obj);
}


GType postler_accounts_get_type (void) {
	static volatile gsize postler_accounts_type_id__volatile = 0;
	if (g_once_init_enter (&postler_accounts_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerAccountsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_accounts_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerAccounts), 0, (GInstanceInitFunc) postler_accounts_instance_init, NULL };
		GType postler_accounts_type_id;
		postler_accounts_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerAccounts", &g_define_type_info, 0);
		g_once_init_leave (&postler_accounts_type_id__volatile, postler_accounts_type_id);
	}
	return postler_accounts_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




