/* postler-state.c generated by valac 0.10.4, the Vala compiler
 * generated from postler-state.vala, do not modify */

/*
 Copyright (C) 2011 Sergio Spinatelli <spinatelli.sergio@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define POSTLER_TYPE_STATE (postler_state_get_type ())
#define POSTLER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POSTLER_TYPE_STATE, PostlerState))
#define POSTLER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POSTLER_TYPE_STATE, PostlerStateClass))
#define POSTLER_IS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POSTLER_TYPE_STATE))
#define POSTLER_IS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POSTLER_TYPE_STATE))
#define POSTLER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POSTLER_TYPE_STATE, PostlerStateClass))

typedef struct _PostlerState PostlerState;
typedef struct _PostlerStateClass PostlerStateClass;
typedef struct _PostlerStatePrivate PostlerStatePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PostlerState {
	GObject parent_instance;
	PostlerStatePrivate * priv;
};

struct _PostlerStateClass {
	GObjectClass parent_class;
};

struct _PostlerStatePrivate {
	char* config_path;
	char* state_file;
	char* group;
	GKeyFile* keyfile;
	gint _width;
	gint _height;
	gint _window_state;
	char* _open_folder;
};


static gpointer postler_state_parent_class = NULL;

GType postler_state_get_type (void) G_GNUC_CONST;
#define POSTLER_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POSTLER_TYPE_STATE, PostlerStatePrivate))
enum  {
	POSTLER_STATE_DUMMY_PROPERTY,
	POSTLER_STATE_WIDTH,
	POSTLER_STATE_HEIGHT,
	POSTLER_STATE_WINDOW_STATE,
	POSTLER_STATE_OPEN_FOLDER
};
PostlerState* postler_state_new (void);
PostlerState* postler_state_construct (GType object_type);
static void postler_state_reload (PostlerState* self);
static void postler_state_write_keyfile (PostlerState* self, GError** error);
void postler_state_update (PostlerState* self);
gint postler_state_get_width (PostlerState* self);
gint postler_state_get_height (PostlerState* self);
gint postler_state_get_window_state (PostlerState* self);
const char* postler_state_get_open_folder (PostlerState* self);
void postler_state_set_width (PostlerState* self, gint value);
void postler_state_set_height (PostlerState* self, gint value);
void postler_state_set_window_state (PostlerState* self, gint value);
void postler_state_set_open_folder (PostlerState* self, const char* value);
static void postler_state_finalize (GObject* obj);
static void postler_state_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void postler_state_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 22 "postler-state.vala"
PostlerState* postler_state_construct (GType object_type) {
#line 92 "postler-state.c"
	PostlerState * self = NULL;
	const char* config_dir;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 22 "postler-state.vala"
	self = (PostlerState*) g_object_new (object_type, NULL);
#line 23 "postler-state.vala"
	config_dir = g_get_user_config_dir ();
#line 24 "postler-state.vala"
	self->priv->config_path = (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (config_dir, "/", NULL), PACKAGE_NAME, NULL), "/", NULL), _g_free0 (self->priv->config_path), _tmp2_);
#line 105 "postler-state.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 25 "postler-state.vala"
	self->priv->state_file = (_tmp3_ = g_strconcat (self->priv->config_path, "staterc", NULL), _g_free0 (self->priv->state_file), _tmp3_);
#line 27 "postler-state.vala"
	postler_state_reload (self);
#line 112 "postler-state.c"
	return self;
}


#line 22 "postler-state.vala"
PostlerState* postler_state_new (void) {
#line 22 "postler-state.vala"
	return postler_state_construct (POSTLER_TYPE_STATE);
#line 121 "postler-state.c"
}


#line 30 "postler-state.vala"
static void postler_state_write_keyfile (PostlerState* self, GError** error) {
#line 127 "postler-state.c"
	char* _tmp0_;
	GError * _inner_error_ = NULL;
#line 30 "postler-state.vala"
	g_return_if_fail (self != NULL);
#line 31 "postler-state.vala"
	if (g_mkdir_with_parents (self->priv->config_path, 0700) != 0) {
#line 134 "postler-state.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, _ ("Config folder couldn't be created."));
		{
			g_propagate_error (error, _inner_error_);
			return;
		}
	}
#line 33 "postler-state.vala"
	g_file_set_contents (self->priv->state_file, _tmp0_ = g_key_file_to_data (self->priv->keyfile, NULL, NULL), -1, &_inner_error_);
#line 143 "postler-state.c"
	_g_free0 (_tmp0_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


#line 36 "postler-state.vala"
void postler_state_update (PostlerState* self) {
#line 154 "postler-state.c"
	GError * _inner_error_ = NULL;
#line 36 "postler-state.vala"
	g_return_if_fail (self != NULL);
#line 158 "postler-state.c"
	{
#line 38 "postler-state.vala"
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "width", self->priv->_width);
#line 39 "postler-state.vala"
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "height", self->priv->_height);
#line 40 "postler-state.vala"
		g_key_file_set_integer (self->priv->keyfile, self->priv->group, "window-state", self->priv->_window_state);
#line 41 "postler-state.vala"
		g_key_file_set_string (self->priv->keyfile, self->priv->group, "open-folder", self->priv->_open_folder);
#line 43 "postler-state.vala"
		postler_state_write_keyfile (self, &_inner_error_);
#line 170 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch73_g_error;
		}
	}
	goto __finally73;
	__catch73_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 45 "postler-state.vala"
			g_critical ("postler-state.vala:45: Failed to save \"%s\": %s", self->priv->state_file, _error_->message);
#line 184 "postler-state.c"
			_g_error_free0 (_error_);
		}
	}
	__finally73:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


#line 49 "postler-state.vala"
static void postler_state_reload (PostlerState* self) {
#line 199 "postler-state.c"
	GKeyFile* _tmp0_;
	GError * _inner_error_ = NULL;
#line 49 "postler-state.vala"
	g_return_if_fail (self != NULL);
#line 50 "postler-state.vala"
	self->priv->keyfile = (_tmp0_ = g_key_file_new (), _g_key_file_free0 (self->priv->keyfile), _tmp0_);
#line 206 "postler-state.c"
	{
#line 52 "postler-state.vala"
		g_key_file_load_from_file (self->priv->keyfile, self->priv->state_file, 0, &_inner_error_);
#line 210 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch74_g_error;
		}
	}
	goto __finally74;
	__catch74_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 55 "postler-state.vala"
			g_debug ("postler-state.vala:55: Failed to load \"%s\": %s", self->priv->state_file, _error_->message);
#line 224 "postler-state.c"
			_g_error_free0 (_error_);
		}
	}
	__finally74:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		gboolean _tmp1_;
		gboolean _tmp3_;
		gboolean _tmp5_;
		gboolean _tmp7_;
#line 59 "postler-state.vala"
		_tmp1_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "width", &_inner_error_);
#line 241 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
#line 59 "postler-state.vala"
		if (_tmp1_) {
#line 247 "postler-state.c"
			gint _tmp2_;
#line 60 "postler-state.vala"
			_tmp2_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "width", &_inner_error_);
#line 251 "postler-state.c"
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
#line 60 "postler-state.vala"
			postler_state_set_width (self, _tmp2_);
#line 257 "postler-state.c"
		}
#line 61 "postler-state.vala"
		_tmp3_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "height", &_inner_error_);
#line 261 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
#line 61 "postler-state.vala"
		if (_tmp3_) {
#line 267 "postler-state.c"
			gint _tmp4_;
#line 62 "postler-state.vala"
			_tmp4_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "height", &_inner_error_);
#line 271 "postler-state.c"
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
#line 62 "postler-state.vala"
			postler_state_set_height (self, _tmp4_);
#line 277 "postler-state.c"
		}
#line 63 "postler-state.vala"
		_tmp5_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "window-state", &_inner_error_);
#line 281 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
#line 63 "postler-state.vala"
		if (_tmp5_) {
#line 287 "postler-state.c"
			gint _tmp6_;
#line 64 "postler-state.vala"
			_tmp6_ = g_key_file_get_integer (self->priv->keyfile, self->priv->group, "window-state", &_inner_error_);
#line 291 "postler-state.c"
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
#line 64 "postler-state.vala"
			postler_state_set_window_state (self, _tmp6_);
#line 297 "postler-state.c"
		}
#line 65 "postler-state.vala"
		_tmp7_ = g_key_file_has_key (self->priv->keyfile, self->priv->group, "open-folder", &_inner_error_);
#line 301 "postler-state.c"
		if (_inner_error_ != NULL) {
			goto __catch75_g_error;
		}
#line 65 "postler-state.vala"
		if (_tmp7_) {
#line 307 "postler-state.c"
			char* _tmp8_;
			char* _tmp9_;
#line 66 "postler-state.vala"
			_tmp8_ = g_key_file_get_string (self->priv->keyfile, self->priv->group, "open-folder", &_inner_error_);
#line 312 "postler-state.c"
			if (_inner_error_ != NULL) {
				goto __catch75_g_error;
			}
#line 66 "postler-state.vala"
			postler_state_set_open_folder (self, _tmp9_ = _tmp8_);
#line 318 "postler-state.c"
			_g_free0 (_tmp9_);
		}
	}
	goto __finally75;
	__catch75_g_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		{
#line 69 "postler-state.vala"
			g_critical (_ ("Failed to parse state in \"%s\": %s"), self->priv->state_file, _error_->message);
#line 331 "postler-state.c"
			_g_error_free0 (_error_);
		}
	}
	__finally75:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gint postler_state_get_width (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_width;
#line 17 "postler-state.vala"
	return result;
#line 350 "postler-state.c"
}


void postler_state_set_width (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_width = value;
	g_object_notify ((GObject *) self, "width");
}


gint postler_state_get_height (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_height;
#line 18 "postler-state.vala"
	return result;
#line 367 "postler-state.c"
}


void postler_state_set_height (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_height = value;
	g_object_notify ((GObject *) self, "height");
}


gint postler_state_get_window_state (PostlerState* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_window_state;
#line 19 "postler-state.vala"
	return result;
#line 384 "postler-state.c"
}


void postler_state_set_window_state (PostlerState* self, gint value) {
	g_return_if_fail (self != NULL);
	self->priv->_window_state = value;
	g_object_notify ((GObject *) self, "window-state");
}


const char* postler_state_get_open_folder (PostlerState* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_open_folder;
#line 20 "postler-state.vala"
	return result;
#line 401 "postler-state.c"
}


void postler_state_set_open_folder (PostlerState* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_open_folder = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_open_folder), _tmp0_);
	g_object_notify ((GObject *) self, "open-folder");
}


static void postler_state_class_init (PostlerStateClass * klass) {
	postler_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PostlerStatePrivate));
	G_OBJECT_CLASS (klass)->get_property = postler_state_get_property;
	G_OBJECT_CLASS (klass)->set_property = postler_state_set_property;
	G_OBJECT_CLASS (klass)->finalize = postler_state_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_WIDTH, g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_HEIGHT, g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_WINDOW_STATE, g_param_spec_int ("window-state", "window-state", "window-state", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POSTLER_STATE_OPEN_FOLDER, g_param_spec_string ("open-folder", "open-folder", "open-folder", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void postler_state_instance_init (PostlerState * self) {
	self->priv = POSTLER_STATE_GET_PRIVATE (self);
	self->priv->group = g_strdup ("state");
	self->priv->_width = 0;
	self->priv->_height = 0;
	self->priv->_window_state = 0;
	self->priv->_open_folder = g_strdup ("");
}


static void postler_state_finalize (GObject* obj) {
	PostlerState * self;
	self = POSTLER_STATE (obj);
	_g_free0 (self->priv->config_path);
	_g_free0 (self->priv->state_file);
	_g_free0 (self->priv->group);
	_g_key_file_free0 (self->priv->keyfile);
	_g_free0 (self->priv->_open_folder);
	G_OBJECT_CLASS (postler_state_parent_class)->finalize (obj);
}


GType postler_state_get_type (void) {
	static volatile gsize postler_state_type_id__volatile = 0;
	if (g_once_init_enter (&postler_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PostlerStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postler_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PostlerState), 0, (GInstanceInitFunc) postler_state_instance_init, NULL };
		GType postler_state_type_id;
		postler_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PostlerState", &g_define_type_info, 0);
		g_once_init_leave (&postler_state_type_id__volatile, postler_state_type_id);
	}
	return postler_state_type_id__volatile;
}


static void postler_state_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PostlerState * self;
	self = POSTLER_STATE (object);
	switch (property_id) {
		case POSTLER_STATE_WIDTH:
		g_value_set_int (value, postler_state_get_width (self));
		break;
		case POSTLER_STATE_HEIGHT:
		g_value_set_int (value, postler_state_get_height (self));
		break;
		case POSTLER_STATE_WINDOW_STATE:
		g_value_set_int (value, postler_state_get_window_state (self));
		break;
		case POSTLER_STATE_OPEN_FOLDER:
		g_value_set_string (value, postler_state_get_open_folder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void postler_state_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PostlerState * self;
	self = POSTLER_STATE (object);
	switch (property_id) {
		case POSTLER_STATE_WIDTH:
		postler_state_set_width (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_HEIGHT:
		postler_state_set_height (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_WINDOW_STATE:
		postler_state_set_window_state (self, g_value_get_int (value));
		break;
		case POSTLER_STATE_OPEN_FOLDER:
		postler_state_set_open_folder (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




